

#include"./library/LenenShot/JINXShot_Const.txt"
#include"./Function_Effect.dnh"
#include"./AudioFunctions.h"

#include"./PixelShaderFunctions.h"

let MainSTG = GetMainStgScriptDirectory;
let FuncSrc;
let DEBUG = true;

local{
	FuncSrc = GetCurrentScriptDirectory;
}

let img_effect = FuncSrc~"img/effect.png"; // Effect Sheet
let img_effect2 = FuncSrc~"img/effect2.png"; // Effect 2 Sheet
let img_effect3 = FuncSrc~"img/effect3.png"; // Effect 3 Sheet
let img_magiccircle = FuncSrc~"img/eff_magiccircle.png"; // Magic Circle
let img_laser = FuncSrc~"img/lasers.png"; // Lifebar
let img_break = FuncSrc~"img/efbreak.png"; // Bullet Break Sheet
let img_fairy = FuncSrc~"img/enemy.png"; // Fairy Sheet
let img_SpellAttack = FuncSrc~"img/effect3/effect37.png"; // Spell Declare
let img_lifebar = FuncSrc~"img/lifebar.png"; // Lifebar
let img_Circle = FuncSrc~"img/Masks/img_Circle.png"; // Circle 
let img_CircleA = FuncSrc~"img/Masks/img_CircleA.png"; // Circle 
let img_Circlecf = FuncSrc~"img/Masks/circlefdai.png"; // Circle center fade
let img_Circlecfs = FuncSrc~"img/Masks/circlefdais.png"; // Circle center fade small 
let img_Outline = FuncSrc~"img/Masks/img_Outline.png"; // Outline 
let img_ScreenCover = FuncSrc~"img/Masks/screen.png"; // Screen cover 

let img_Blank = FuncSrc~"img/Masks/blank.png"; // Blank 

let img_Cloud = FuncSrc~"img/Cloud.png"; // Cloud 


let Enemy = ID_INVALID;
let objScene = GetEnemyBossSceneObjectID;
let packageScript = GetAreaCommonData("GlobalVariables", "PackageScriptID", ID_INVALID);

let time = 0;
let frame = 0;
let angle = 0;
let frame2 = 0;
let angle2 = 0;
let loopval = 10;


let DIFFICULTY_EASY = 12;
let DIFFICULTY_NORMAL = 36;
let DIFFICULTY_HARD = 48;
let DIFFICULTY_EXTRA = 60;
let DIFFICULTY_LUNATIC = 72;
let DIFFICULTY_OVERDRIVE = 96;
let DIFFICULTY_CIRNO = 120;

let EV_DAMAGE_SHIELD = EV_USER_SYSTEM+10;
let EV_DAMAGE_CHIP_SHIELD = EV_USER_SYSTEM+12;
let EV_DAMAGE_CHIP_SHIELD_LETHAL = EV_USER_SYSTEM+20;
let EV_DAMAGE_CHIP_HEALTH = EV_USER_SYSTEM+11;
let EV_DAMAGE_CHIP_HEALTH_LETHAL = EV_USER_SYSTEM+21;
let EV_REGEN_HEALTH_OR_SHIELD = EV_USER_SYSTEM+30;

let IsDoubleBattle = GetAreaCommonData("GlobalVariables", "IsDoubleBattle", false);
let GetStageIndex = GetAreaCommonData("GlobalVariables", "StageIndex", 1);
let GetColorPrimary = GetAreaCommonData("GlobalVariables", "StageColorBoss", [255, 255, 255]);
let GetColorSecondary = GetAreaCommonData("GlobalVariables", "StageColorMidboss", [128, 128, 128]);
let argument = GetAreaCommonData("GlobalVariables", "GameDifficulty", 48);

let GetCenterX = GetStgFrameWidth/2;
let GetCenterY = GetStgFrameHeight/2;
let LastTimeStop = 0;
let IsTimeStopped = false;
let bosstime = 99;
let TimeSpeed = 1;

let Anim_Attack = 0;
let GetScreenOffsetX = Get2DCameraX-192;
let ScreenMoveSpeed = [0, 0];
let IsAttackAnimPlaying = false;

let EnemyX = GetCommonData("StarX1", 0);
let EnemyY = GetCommonData("StarY1", 0);

let EnemyDead = false;
let IsEnemyBounded = true;
let IsEnemyBounding = true;
let quality = GetCommonData("quality", 0);

let TotalEffectMax = 24*quality;
let TotalEffect = 0;

let GlobalOptions = GetAreaCommonData("OptionConfig", "Options", [[80, 80, 2, 3, 2, 0], [1, 0, 0]])[0];
let SE_VOL = GlobalOptions[1];
let CustomNum = 0;

let EV_SIGIL_ON = EV_USER+144;
let EV_SIGIL_OFF = EV_USER+143;

let EnemyRender = GetCommonData("WORKAROUNDOFTHECENTURY", ID_INVALID);
let WarningRender = ID_INVALID;
let SpotlightRender = ID_INVALID;
let BreakRender = ID_INVALID;
let NukeRender = ID_INVALID;

let PoisonDamage = 0.09+argument^0.34/3;

let HITBOX_NONE = 0;
let HITBOX_SOLO = 1;
let HITBOX_PARENT = 2;
let HITBOX_DUAL = 3;

task InitiateFlashlightAttack{
	InitiateFlashlightAttackA2(255, 227, 74);
}

task InitiateFlashlightAttackA2(red, green, blue){
	
	let rendt = "FlashLightRenderTarget";
	if(!CreateRenderTarget(rendt)){RaiseError("Unable to create image.");}
	
	SpotlightRender = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	Obj_SetRenderPriority(SpotlightRender, 0.48);
	ObjPrim_SetTexture(SpotlightRender, FuncSrc~"img/Masks/img_spotlight.png");
	ObjSpriteList2D_SetSourceRect(SpotlightRender, 0, 1, 384, 1024);
	ObjSpriteList2D_SetDestRect(SpotlightRender, -192, 0, 192, 1024);
	
	let FlashOutput = ObjPrim_Create(OBJ_SPRITE_2D);
	Obj_SetRenderPriorityI(FlashOutput, 47);
	ObjPrim_SetTexture(FlashOutput, rendt);
	ObjSprite2D_SetSourceRect(FlashOutput, 0, 0, 640, 480);
	ObjSprite2D_SetDestRect(FlashOutput, 0, 0, 640, 480);
	
	
	MaskedShaderC1(SpotlightRender, img_Blank, 47, 0, 0, 1, red, green, blue, 150);
	
	SetInvalidRenderPriorityA1(48, 48);
	while(!EnemyDead){
		ObjSpriteList2D_ClearVertexCount(SpotlightRender);
		yield;
		RenderToTextureB1(rendt, SpotlightRender, true);
	}
	ClearInvalidRenderPriority();
	
	// RemoveTexture(rendt);
	Obj_Delete(SpotlightRender);
	Obj_Delete(FlashOutput);
}



function FireFlashlightBeam(x, y, xscl, yscl, ang, duration){
	let obj = ObjEnemy_Create(OBJ_ENEMY);
	DoStuff;
	return obj;
	
	task DoStuff{
		duration = round(duration);
		let rwid = 0;
		let rxsc = 0;
		let bwid = 384*xscl;
		let hoff = 0;
		let bhei = 1024*yscl-hoff;
		
		// let rectx = x+bhei*cos(ang)/2+bwid*cos(ang+90)/10;
		// let recty = x+bwid*sin(ang)/2+bhei*sin(ang+90)/10;
		let rectx = x+bhei*cos(ang)/2*1.15;
		let recty = y+bhei*sin(ang)/2*1.15;
		
		bwid*=1.1;
		
		
		

		while(!Obj_IsDeleted(SpotlightRender) && duration != 0){
			duration--;
			if(rwid < bwid){
				rwid = min(rwid+bwid/10, bwid);
				rxsc = min(rxsc+xscl/10, xscl);
			}
			DoRender;
			yield;
		}
		
		descent(i in 0..8){
			rwid = max(rwid-bwid/8, 0);
			rxsc = max(rxsc-xscl/8, 0);
			DoRender;
			yield;
		}
		Obj_Delete(obj);
		
		
		sub DoRender{
			if(ang != Obj_GetValueD(obj, "FlashLight_Angle", ang)){
				ang = Obj_GetValueD(obj, "FlashLight_Angle", ang);
				rectx = x+bhei*cos(ang)/2*1.15;
				recty = y+bhei*sin(ang)/2*1.15;
			}
			ObjRender_SetAngleZ(SpotlightRender, ang-90);
			
			ObjRender_SetPosition(SpotlightRender, x, y, 0);
			ObjRender_SetScaleXYZ(SpotlightRender, rxsc, yscl, 1);
			ObjRender_SetColor(SpotlightRender, 255, 255, 255);
			
			
			// if(AngleToPlayer(x, y)%180+180 - ang%360+90 > 180){
				// ObjRender_SetColor(SpotlightRender, 255, 23, 255);
				if(Collision_Box_Box(rectx, recty, bhei, rwid, ang, GetPlayerX, GetPlayerY, 1, 1, ang)){
					ObjRender_SetColor(SpotlightRender, 255, 0, 0);
					ObjSpriteList2D_AddVertex(SpotlightRender);
					
					PlaySoundO2(se_down, 85);
					NotifyEventAll(EV_DAMAGE_CHIP_SHIELD_LETHAL, PoisonDamage);
					let pyscl = min(0.37, yscl);
					let prhei = pyscl * 1024-4;
					ObjRender_SetAngleZ(SpotlightRender, ang-90+180);
					// ObjRender_SetPosition(SpotlightRender, GetPlayerX, GetPlayerY, 0);
					ObjRender_SetPosition(SpotlightRender, GetPlayerX+prhei*cos(ang), GetPlayerY+prhei*sin(ang), 0);
					ObjRender_SetScaleXYZ(SpotlightRender, 0.02, pyscl, 1);
					ObjRender_SetColor(SpotlightRender, 0, 0, 0);
					let bind = ObjPrim_GetVertexCount(SpotlightRender);
					
					ObjSpriteList2D_AddVertex(SpotlightRender);
					// ObjPrim_SetVertexColor(SpotlightRender, bind+0, 0, 0, 0);
					// ObjPrim_SetVertexColor(SpotlightRender, bind+1, 0, 0, 0);
					// ObjPrim_SetVertexColor(SpotlightRender, bind+0, 255, 255, 255);
					// ObjPrim_SetVertexColor(SpotlightRender, bind+2, 255, 255, 255);
					// ObjPrim_SetVertexColor(SpotlightRender, bind+3, 255, 255, 255);
				// }else{
					// ObjSpriteList2D_AddVertex(SpotlightRender);
				// }
			}else{
				ObjSpriteList2D_AddVertex(SpotlightRender);
			}
		}
		
	}
}

function CreateMarisaSlaveA1(x, y, xoff, yoff, delay){
	let enm = ObjEnemy_Create(OBJ_ENEMY);
	ObjMove_SetPosition(enm, x, y);
	ObjEnemy_Regist(enm);
	let life = 65500;
	ObjEnemy_SetLife(enm, 65500);
	// SetInvincibility(enm, 5, 0.1, 0.1);
	Obj_SetValue(enm, "Damage", 51+argument*0.4);
	PlaySoundO2(se_boon01, 75);

	let scl = 0;
	
	DoFunctions;
	
	return enm;
	
	
	task DoFunctions{
		let iscl = 1;
		ascent(i in 0..delay){
			scl = Obj_GetValueD(enm, "EnemyScale", iscl)*iscl/(delay-1)*i;
			RenderObject;
			yield;
		}
		while(!EnemyDead){
			if(Obj_GetValueD(enm, "EnemyAutoDelete", true)){
				if(CheckOutsideScreenA1(enm, 64*scl)){
					break;
				}
			}
			if(life != ObjEnemy_GetInfo(enm, INFO_LIFE)){
				life = ObjEnemy_GetInfo(enm, INFO_LIFE);
				PlaySoundO2(se_nodamage, 80);
			}
			scl = Obj_GetValueD(enm, "EnemyScale", scl);
			ObjEnemy_SetIntersectionCircleToShot(enm, x, y, 34*scl);
			ObjEnemy_SetIntersectionCircleToPlayer(enm, x, y, 34*scl);
			RenderObject;
			if(!Hold(1)){break;}
		}
		iscl = scl;
		descent(i in 0..9){
			scl = iscl/8*i;
			RenderObject;
			yield;
		}
		
		Obj_Delete(enm);
	}
	
	function RenderObject{
		x = ObjMove_GetX(enm);
		y = ObjMove_GetY(enm);
		
		ObjRender_SetPosition(EnemyRender, x, y, 0);
		let mod = (1-1/8+scl);
		ObjRender_SetScaleXYZ(EnemyRender, scl, scl, 1);
		
		ObjRender_SetAlpha(EnemyRender, 255);
		// ObjRender_SetColor(EnemyRender, 255, 255, 255);
		ObjSpriteList2D_SetSourceRect(EnemyRender, xoff, yoff, 80+xoff, 80+yoff);
		ObjSpriteList2D_SetDestCenter(EnemyRender);
		ObjSpriteList2D_AddVertex(EnemyRender);
	}
}



task EyesOfLunacyA1(duration, path, left, top, right, bottom){
	if(EnemyDead){return;}

	PlaySoundO2(se_boon01, 100);
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_SUBTRACT);

	
	let render = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	ObjRender_SetBlendType(render, BLEND_ADD_ARGB);
	Obj_SetRenderPriority(render, 0.29);
	ObjPrim_SetTexture(render, path);
	ObjSpriteList2D_SetSourceRect(render, left, top, right, bottom);
	ObjSpriteList2D_SetDestCenter(render);
	ObjRender_SetPosition(render, GetStgFrameWidth/2, GetStgFrameHeight/2, 0);
	DoStuff;
	


	let malph = 255;
	
	Obj_SetRenderPriority(obj, 0.29);
	ObjPrim_SetTexture(obj, img_Blank);
	ObjSprite2D_SetSourceRect(obj, 492, 492, 512, 512);
	ObjSprite2D_SetDestRect(obj, -64, -64, GetScreenWidth+64, GetScreenHeight+64);
	ObjRender_SetColor(obj, 0, 0, 0);
	ObjRender_SetAlpha(obj, 0);
	ObjRender_SetColor(obj, 0, 96, 96);
	
	
	LunaticFadeIn(50);
	
	let fade = 0;
	let cm = 0;
	
	ascent(i in 0..12){
		fade = min(1, i/11);
		ObjRender_SetAlpha(obj, malph*fade);
		if(!Hold(1)){break;}
	}
	
	ascent(i in 0..duration){
		if(!Hold(1)){break;}
	}
	
	descent(i in 0..25){
		fade = min(1, i/25);
		ObjRender_SetAlpha(obj, malph*fade);
		yield;
	}
	
	Obj_Delete(obj);
	
	sub ChangeColor{
		let shf = 16*sin(cm);
		ObjRender_SetColor(obj, (48+shf)*fade, 64*fade, (48-shf)*fade);
		cm += 1.35;
	}
	
	task DoStuff{
		while(!Obj_IsDeleted(obj)){
			ObjSpriteList2D_ClearVertexCount(render);
			yield;
		}
		loop(25){yield;}
		Obj_Delete(render);
	}
	
	task LunaticFadeIn(dur){
		let tc = floor(dur/2);
		descent(i in 0..tc){
			FireEye(15, 0.75/tc*i, 0, 15);
			if(!Hold(2)){break;}
		}
		ascent(i in 0..5){
			FireEye(15, 0.01, 15-i*3, 5);
			if(!Hold(3)){break;}
		}
	}
	
	
	task FireEye(d, s, dur, out){
		let alph = 255;
		let scl = 0.75+s;
	
		descent(i in 0..d){
			alph = min(alph+10, 192);
			scl = 0.75+s/(d-1)*i;
			SetProp;
			if(!Hold(1)){break;}
		}
		alph = 192;
		scl = 0.75;
		ascent(i in 0..dur){
			let scl = 0.75;
			SetProp;
			if(!Hold(1)){break;}
		}
		descent(i in 0..15){
			alph = 192/14*i;
			SetProp;
			if(!Hold(1)){break;}
		}
		
		sub SetProp{
			ObjRender_SetScaleXYZ(render, scl, scl, 1);
			ObjRender_SetAlpha(render, alph);
			ObjSpriteList2D_AddVertex(render);
		}
	}
	
}




task FireWarningCircleA1(x, y, spd, dist1, dist2){
	let duration = ceil(absolute(dist2-dist1)/spd);
	
	let diff = dist2-dist1;
	
	let angle = rand(0, 360);
	
	ascent(i in 0..duration){
		let rdist = dist1+diff/duration*i;
		loop(2){
			CreateWarningCircleS1(x+rdist*cos(angle), y+rdist*sin(angle), 60);
			angle += 180;
		}
		angle += 33;
		if(!Hold(1)){break;}
	}
	
}


task FireWarningPathA1(x, y, spd, ang, wid){

	let xm = spd*cos(ang);
	let ym = spd*sin(ang);
	
	let xms = wid*cos(ang+90)/2;
	let yms = wid*sin(ang+90)/2;
	
	
	while(!CheckOutsideScreenA2(x, y, 16)){
	
		x+=xm;
		y+=ym;
	
		CreateWarningCircleS1(x+rand(-1, 1)*xms, y+rand(-1, 1)*yms, 60);
		// CreateWarningCircleS1(x+xms, y+yms, 60);
		// CreateWarningCircleS1(x-xms, y-yms, 60);
		
		if(!Hold(1)){break;}
	}
}


task FireNukeLaserA1(x, y, ang, duration){
	let tscl = 0.7;

	let count = round(duration/3);
	
	ascent(i in 0..count){
		let nuke = CreateLargeNukeA1(x, y);
		Obj_SetValue(nuke, "NukePulseSpeed", 24);
		Obj_SetValue(nuke, "NukePulseDistance", 0.135);
		Obj_SetValue(nuke, "NukePulseAngleStart", -21*i);
		DoStuff(nuke);
		ObjMove_SetSpeed(nuke,12);
		ObjMove_SetAngle(nuke,ang);
		if(!Hold(3)){break;}
	}
	let nuke = CreateLargeNukeA1(x, y);
	ObjMove_SetSpeed(nuke,12);
	ObjMove_SetAngle(nuke,ang);
	Obj_SetValue(nuke, "NukePulseDistance", 0.155);
	Obj_SetValue(nuke, "NukePulseAngleStart", -21*count);
	DoStuff(nuke);
	
	task DoStuff(obj){
		let nx = x;
		let ny = y;
		ascent(i in 0..9){
			Obj_SetValue(obj, "NukeScale", tscl/(8)*i);
			if(!Hold(1)){break;}
		}
		while(!CheckOutsideScreenA2(nx, ny, 256*tscl)){
			nx = ObjMove_GetX(obj);
			ny = ObjMove_GetY(obj);
			if(!Hold(1)){break;}
		}
		Obj_Delete(obj);
	}
}


function CreateFakeUtsuhoA1(x, y){
	return CreateFakeUtsuhoA2(GetCurrentScriptDirectory~"boss.png", x, y);
}

function CreateFakeUtsuhoA2(path, x, y){
	let obj = ObjEnemy_Create(OBJ_ENEMY);
	ObjEnemy_Regist(obj);
	ObjPrim_SetTexture(obj, path);

	if(quality == 0){
		// ObjPrim_SetTexture(obj, current~"boss1iNS.png");
	}else{
		// ObjPrim_SetTexture(obj, imgEnemy);
		DoShaderEffect;
	}
	//SetEnemyAnimation_UtsuhoA1(obj);
	ObjMove_SetPosition(obj, x, y);
	ObjRender_SetAlpha(obj, 0);
	DoStuff;
	return obj;
	
	
	task DoStuff{
		yield;
		if(Obj_GetValueD(obj, "EnemyDefaults", true)){
			ObjRender_SetColor(obj, 172, 172, 172);
			ObjRender_SetAlpha(obj, 172);
		}
		ObjEnemy_SetLife(obj, Obj_GetValueD(obj, "EnemyLife", 300));
		if(Obj_GetValueD(obj, "HitboxType", 0) != HITBOX_NONE){
			SetUpDamagingVisualA1(obj);
			if(Obj_GetValueD(obj, "HitboxType", 0) == HITBOX_PARENT){
				ObjEnemy_SetLife(obj, ObjEnemy_GetInfo(Enemy, INFO_LIFE));
			}
		}
		while(!Obj_IsDeleted(obj) && !EnemyDead){
			let lx = ObjMove_GetX(obj);
			let ly = ObjMove_GetY(obj);
			alternative(Obj_GetValueD(obj, "HitboxType", 0))
			case(HITBOX_SOLO){
				ObjEnemy_SetIntersectionCircleToShot(obj, lx, ly, 32);
				ObjEnemy_SetIntersectionCircleToPlayer(obj, lx, ly, 24);
			}
			case(HITBOX_PARENT){
				ObjEnemy_SetLife(obj, ObjEnemy_GetInfo(Enemy, INFO_LIFE));
				ObjEnemy_SetIntersectionCircleToShot(Enemy, lx, ly, 32);
				ObjEnemy_SetIntersectionCircleToPlayer(Enemy, lx, ly, 24);
			}
			case(HITBOX_DUAL){
				ObjEnemy_SetIntersectionCircleToShot(obj, lx, ly, 32);
				ObjEnemy_SetIntersectionCircleToShot(Enemy, lx, ly, 32);
				ObjEnemy_SetIntersectionCircleToPlayer(obj, lx, ly, 24);
			}
			yield;
		}
		Obj_Delete(obj);
	}
	task DoShaderEffect{
	
		yield;
		if(!Obj_GetValueD(obj, "DoShaderEffect", true)){return;}
	
		let pathShader = libSrc~"warp_harsh.hlsl";
		ObjShader_SetShaderF(obj, pathShader);
		ObjShader_SetTechnique(obj, "TecMain");
		
		let frame = round(rand(0, 360));
		let mint = 0.01;
		let speed = 20;
		
		ObjShader_SetFloat(obj, "p_int", mint);
		
		
		while(!Obj_IsDeleted(obj)){
			ObjShader_SetFloat(obj, "p_frame", frame);
			frame+=speed;
			yield;
		}
		
	}
}


task CreateWarningCircleS1(x, y, duration){
	let scl = 0;
	
	ascent(i in 0..12){
		scl = i/11;
		RenderObject;
		yield;
	}
	
	loop(duration){
		RenderObject;
		if(!Hold(1)){break;}
	}
	
	descent(i in 0..12){
		scl = i/11;
		RenderObject;
		yield;
	}
	
	function RenderObject{
		let spin = rand(0,360);
		ObjRender_SetPosition(WarningRender, x, y, 0);
		ObjRender_SetScaleXYZ(WarningRender, scl, scl, 1);
		
		ObjRender_SetAngleZ(WarningRender, -spin);
		ObjSpriteList2D_AddVertex(WarningRender);
	}
}


task SetUpDamagingVisualA1(obj){
	let bhp = ObjEnemy_GetInfo(obj, INFO_LIFE);
	let chp = bhp;
	
	while(!Obj_IsDeleted(obj)){
		
		chp = ObjEnemy_GetInfo(obj, INFO_LIFE);
		
		if(bhp > chp){	
			ObjRender_SetColor(obj, 32, 32, 255);
			bhp = chp;
		}
		bhp = chp;
		
		yield;
		ObjRender_SetColor(obj, 255, 255, 255);
		yield;
		yield;
		loop(round(rand(1, 3))){yield;}
	}
}

function SetUpDamagingVisualC1(obj){
	let chp = ObjEnemy_GetInfo(obj, INFO_LIFE);
	Obj_SetValue(obj, "chp", chp);
	if(Obj_GetValueD(obj, "bhp", chp) != chp){
		Obj_SetValue(obj, "bhp", chp);
		return true;
	}
	return false;
}



function CheckForReisenQualitySettingA1(obj, value){
	if(quality == 0){
		if(value){
			ObjRender_SetColor(obj, 192, 48, 32);
			ObjRender_SetAlpha(obj, 128);
		}else{
			ObjRender_SetColor(obj, 255, 255, 255);
			ObjRender_SetAlpha(obj, 255);
		}
	}
}


task SetUpNukeRenders{
	// EnemyRender = InitRender(EnemyRender, 0.37, current~"nuke.png");
	NukeRender = InitRender(NukeRender, 0.37, FuncSrc~"img/nuke.png");
	ObjRender_SetBlendType(NukeRender, BLEND_ADD_ARGB);
	// ObjRender_SetBlendType(EnemyRender, BLEND_ADD_ARGB);
}

function CreateLargeNukeA1(x, y){
	let r = 255;
	let g = 64;
	let b = 42;
	
	let ir = 212;
	let ig = 192;
	let ib = 192;
	
	//x,y coordinates
	//l,
	let obj = ObjEnemy_Create(OBJ_ENEMY);
	ObjMove_SetPosition(obj, x, y);
	ObjEnemy_Regist(obj);
	Obj_SetValue(obj, "Damage", 70+argument*2);

	let spin = 0;
	let spid = 1 - 2*round(rand(0, 1));
	spid *= 1.6;
	let scl = 1;
	let alph = 192;
	let dscl = 0;
	let dsclm = 0;
	
	DoFunctions;
	
	return obj;
	
	
	task DoFunctions{
		yield;
		dsclm = Obj_GetValueD(obj, "NukePulseAngleStart", dsclm);
		while(!Obj_IsDeleted(obj)){
			// if(CheckOutsideScreenA1(obj, 256)){
				// Obj_Delete(obj);
				// return;
			// }
			x = ObjMove_GetX(obj);
			y = ObjMove_GetY(obj);
			dsclm += Obj_GetValueD(obj, "NukePulseSpeed", 5);
			dscl = scl*Obj_GetValueD(obj, "NukePulseDistance", 0.075)*cos(dsclm);
			scl = Obj_GetValueD(obj, "NukeScale", scl);
			alph = Obj_GetValueD(obj, "NukeAlpha", alph);
			if(!Obj_GetValueD(obj, "NukeHitbox", false)){
				ObjEnemy_SetIntersectionCircleToPlayer(obj, x, y, 86*scl);
			}
			
			let oncol = Obj_GetValueD(obj, "NukeColorOuter", [r, g, b]);
			let incol = Obj_GetValueD(obj, "NukeColorInner", [ir, ig, ib]);
			r = oncol[0];
			g = oncol[1];
			b = oncol[2];
			ir = incol[0];
			ig = incol[1];
			ib = incol[2];
			
			RenderObject;
			// scl = 0.7+0.3*cos(spin);
			yield;
		}
		
		// while(!Obj_IsDeleted(nuke) && tscl > 0.15){
			// tscl-=0.08;
			// Obj_SetValue(nuke, "NukeScale", tscl);
			// yield;
		// }
		
		// ExplosionA1(obj, Obj_GetValueD(obj, "NukeGraphic", "CHERRY"),
			// [r, g, b],
			// [r, g, b]);
		yield;
		// Obj_Delete(obj);
	}
	
	function RenderObject{
		ObjRender_SetPosition(NukeRender, x, y, 0);
		ObjRender_SetPosition(NukeRender, x, y, 0);
		let mod = (1-1/8+scl);
		spin+=spid/(mod*6-5);
		
		
		ObjRender_SetColor(NukeRender, r, g, b);
		ObjRender_SetAlpha(NukeRender, alph);
		ObjRender_SetAlpha(NukeRender, alph);
		ObjRender_SetAngleZ(NukeRender, spin);
		ObjRender_SetAngleZ(NukeRender, spin);
		
		
		ObjRender_SetScaleXYZ(NukeRender, scl*1.15+dscl, scl*1.15+dscl, 1);
		ObjSpriteList2D_SetSourceRect(NukeRender, 256, 0, 512, 256);
		ObjSpriteList2D_SetDestCenter(NukeRender);
		ObjSpriteList2D_AddVertex(NukeRender);
		
		
		ObjRender_SetColor(NukeRender, ir, ig, ib);
		
		ObjRender_SetScaleXYZ(NukeRender, scl+dscl*0.35, scl+dscl*0.35, 1);
		ObjSpriteList2D_SetSourceRect(NukeRender, 0, 0, 256, 256);
		ObjSpriteList2D_SetDestCenter(NukeRender);
		ObjSpriteList2D_AddVertex(NukeRender);
		
	}
}


task ReisenBlurA1(priority, dur){

	EyesOfLunacyA1(dur, GetCurrentScriptDirectory~"RedEyeRaven.png", 0, 0, 256, 128);
	BasicBlurA1(priority, priority, 10, dur, 16);
}

task ReisenBlurB1(priority, idur, dur, edur){
	EyesOfLunacyA1(dur, GetCurrentScriptDirectory~"RedEyeRaven.png", 0, 0, 256, 128);
	BasicBlurA1(priority, priority, idur, dur, edur);
}



function CreateBirdShotA2(x, y, spd, ang, acc, maxspd, graph, delay){
	let shot = ObjShot_Create(OBJ_SHOT);
	PlaySoundO1(se_tan00);
	CreateBirdShotAC2(shot, x, y, spd, ang, acc, maxspd, graph, delay);
	return shot;
}

task CreateBirdShotAC2(objShot, x, y, spd, ang, acc, maxspd, graph, delay){

	loop(max(0, delay-45)){yield;}

	ObjShot_Regist(objShot);
	ObjMove_SetPosition(objShot, x, y);
	ObjMove_SetAngle(objShot, ang);
	ObjShot_SetGraphic(objShot, graph);

	ObjShot_SetIntersectionEnable(objShot, false);
	ObjRender_SetAlpha(objShot, 0);
	
	Obj_SetValue(objShot, "g_Coll_Ignore_Spawning", true);
	let i = 0;
	
	// let bcol = GetShotDataInfoA1(graph, TARGET_ENEMY, INFO_DELAY_COLOR);
	
	// let r = bcol[0];
	// let g = bcol[1];
	// let b = bcol[2];
	
	let rang = rand(0, 360);
	
	ascent(i in 0..delay){
		if(Obj_IsDeleted(objShot)){return;}
		let alpf = i*(225/delay);
		let scl = (delay-i)*(2.15/delay);
		// ObjRender_SetColor(WarningRender, r, g, b);
		ObjRender_SetAngleZ(WarningRender, rang);
		ObjRender_SetPosition(WarningRender, x, y, 0);
		ObjRender_SetScaleXYZ(WarningRender, scl+1, scl+1, 1);
		
		
		ObjRender_SetAlpha(WarningRender, alpf);
		ObjRender_SetAlpha(objShot, alpf);
		
		let nscl = scl*0.12;
		ObjRender_SetScaleXYZ(objShot, 1-nscl, 1-nscl, 1);
		
		
		
		ObjSpriteList2D_AddVertex(WarningRender);
		yield;
	}
	
	
	
	ObjMove_SetSpeed(objShot, spd);
	ObjMove_SetAcceleration(objShot, acc);
	ObjMove_SetMaxSpeed(objShot, maxspd);
	Obj_SetValue(objShot, "g_Coll_Ignore_Spawning", false);
	GiveCollision(objShot);
	ObjRender_SetScaleXYZ(objShot, 1, 1, 1);
	ObjRender_SetAlpha(objShot, 255);
}



function SetHitboxStateA1(obj, value){
	Obj_SetValue(obj, "g_Coll_Ignore", !value);
	Obj_SetValue(obj, "g_Coll", value);
	ObjShot_SetIntersectionEnable(obj, value);
}


function Collision_Box_Box(cx1, cy1, w1, h1, r1, cx2, cy2, w2, h2, r2){
    let rectA = CalculateCorners(cx1, cy1, w1, h1, r1);
    let rectB = CalculateCorners(cx2, cy2, w2, h2, r2);

    let axisList = [
        rectA[1] - rectA[0],
        rectA[1] - rectA[2],
        rectB[0] - rectB[3],
        rectB[0] - rectB[1]
    ];
    
    ascent(i in 0..4){
        if(!IsAxisCollision(axisList[i])){
            return false;
        }
    }
    
    return true;
    
    
    function CalculateCorners(cx, cy, width, height, rotation){
        if(rotation == 0){
            return [
                [cx-width/2, cy-height/2],
                [cx+width/2, cy-height/2],
                [cx+width/2, cy+height/2],
                [cx-width/2, cy+height/2]
            ];
        }
        else {
            let angles = [
                atan2(height/-2, width/-2)+rotation,
                atan2(height/2, width/-2)+rotation,
                atan2(height/2, width/2)+rotation,
                atan2(height/-2, width/2)+rotation
            ];
            let distance = (height^2 + width^2)^0.5/2;
            return [
                [cx+cos(angles[0])*distance, cy+sin(angles[0])*distance],
                [cx+cos(angles[1])*distance, cy+sin(angles[1])*distance],
                [cx+cos(angles[2])*distance, cy+sin(angles[2])*distance],
                [cx+cos(angles[3])*distance, cy+sin(angles[3])*distance]
            ];
        }
    }
    
    
    function IsAxisCollision(axis){
        let rectAScalars = [
            GenerateScalar(rectA[0], axis),
            GenerateScalar(rectA[1], axis),
            GenerateScalar(rectA[2], axis),
            GenerateScalar(rectA[3], axis)
        ];
        let rectBScalars = [
            GenerateScalar(rectB[0], axis),
            GenerateScalar(rectB[1], axis),
            GenerateScalar(rectB[2], axis),
            GenerateScalar(rectB[3], axis)
        ];
        
        let rectAMin = ArrayMin(rectAScalars);
        let rectAMax = ArrayMax(rectAScalars);
        let rectBMin = ArrayMin(rectBScalars);
        let rectBMax = ArrayMax(rectBScalars);

        if(rectBMax <= rectAMax && rectBMax >= rectAMin){
            return true;
        }
        else if (rectAMax <= rectBMax && rectAMax >= rectBMin){
            return true;
        }

        return false;
    }
    
    
    function GenerateScalar(corner, axis){
        let num = (corner[0] * axis[0]) + (corner[1] * axis[1]);
        let denom = (axis[0] * axis[0]) + (axis[1] * axis[1]);
        let divisionResult = num / denom;
        
        let cornerProjected = [divisionResult * axis[0], divisionResult * axis[1]];
        
        let scalar = (axis[0] * cornerProjected[0]) + (axis[1] * cornerProjected[1]);
        return scalar;
    }
}


function Collision_Box_Point(cx1, cy1, w1, h1, r1, cx2, cy2){
    let rectA = CalculateCorners(cx1, cy1, w1, h1, r1);
    let rectB;

    // let axisList = [
        // rectA[1] - rectA[0],
        // rectA[1] - rectA[2],
        // rectB[0] - rectB[3],
        // rectB[0] - rectB[1]
    // ];
    
    // ascent(i in 0..4){
        // if(!IsAxisCollision(axisList[i])){
            // return false;
        // }
    // }
	
	let ndist = GetDistance(cx1, cy1, cx2, cy2);
	let nang = AngleToLocation(cx1, cy1, cx2, cy2)+r1;
	
	let nx = cx1+ndist*cos(nang);
	let ny = cy1+ndist*sin(nang);
	
	
	if(nx > rectA[0][0] && ny > rectA[0][1] && 
	nx < rectA[2][0] && ny < rectA[2][1]){
		return true;
	}
    
    return false;
    
    
    function CalculateCorners(cx, cy, width, height, rotation){
        if(rotation == 0){
            return [
                [cx-width/2, cy-height/2],
                [cx+width/2, cy-height/2],
                [cx+width/2, cy+height/2],
                [cx-width/2, cy+height/2]
            ];
        }
        else {
            let angles = [
                atan2(height/-2, width/-2)+rotation,
                atan2(height/2, width/-2)+rotation,
                atan2(height/2, width/2)+rotation,
                atan2(height/-2, width/2)+rotation
            ];
            let distance = (height^2 + width^2)^0.5/2;
            return [
                [cx+cos(angles[0])*distance, cy+sin(angles[0])*distance],
                [cx+cos(angles[1])*distance, cy+sin(angles[1])*distance],
                [cx+cos(angles[2])*distance, cy+sin(angles[2])*distance],
                [cx+cos(angles[3])*distance, cy+sin(angles[3])*distance]
            ];
        }
    }
    
    
    function IsAxisCollision(axis){
        let rectAScalars = [
            GenerateScalar(rectA[0], axis),
            GenerateScalar(rectA[1], axis),
            GenerateScalar(rectA[2], axis),
            GenerateScalar(rectA[3], axis)
        ];
        let rectBScalars = [
            GenerateScalar(rectB[0], axis),
            GenerateScalar(rectB[1], axis),
            GenerateScalar(rectB[2], axis),
            GenerateScalar(rectB[3], axis)
        ];
        
        let rectAMin = ArrayMin(rectAScalars);
        let rectAMax = ArrayMax(rectAScalars);
        let rectBMin = ArrayMin(rectBScalars);
        let rectBMax = ArrayMax(rectBScalars);

        if(rectBMax <= rectAMax && rectBMax >= rectAMin){
            return true;
        }
        else if (rectAMax <= rectBMax && rectAMax >= rectBMin){
            return true;
        }

        return false;
    }
    
    
    function GenerateScalar(corner, axis){
        let num = (corner[0] * axis[0]) + (corner[1] * axis[1]);
        let denom = (axis[0] * axis[0]) + (axis[1] * axis[1]);
        let divisionResult = num / denom;
        
        let cornerProjected = [divisionResult * axis[0], divisionResult * axis[1]];
        
        let scalar = (axis[0] * cornerProjected[0]) + (axis[1] * cornerProjected[1]);
        return scalar;
    }
}

function ArrayMin(array){
    let min = array[0];
    ascent(i in 1..length(array)){
        if(array[i] < min){ min = array[i]; }
	}
    return min;
}

function ArrayMax(array){
    let max = array[0];
    ascent(i in 1..length(array)){
        if(array[i] > max){ max = array[i]; }
    }
    return max;
}



function GetActiveBoss(obj){
	return Obj_GetValueD(obj, "PP_ActiveBoss", "Default");
}

task SwapCharacter(obj, img, target){
	ObjPrim_SetTexture(obj, img); 
	if(target == "Seija"){
		ObjAnim_SetAnimationPauseA1(obj, "Seija", false);
		ObjAnim_SetAnimationPauseA1(obj, "Tenshi", true);
		Obj_SetValue(obj, "PP_ActiveBoss", "Seija");
	}else{
		ObjAnim_SetAnimationPauseA1(obj, "Seija", true);
		ObjAnim_SetAnimationPauseA1(obj, "Tenshi", false);
		Obj_SetValue(obj, "PP_ActiveBoss", "Tenshi");
	}
	Obj_SetVisible(obj, false);
	yield;
	Obj_SetVisible(obj, true);
}

function SetFullScreenSingle{

	SetStgFrame(0, 0, 640, 480, 20, 80);
	let frame = GetCommonData("PreviousFrameID", ID_INVALID);
	ObjMove_SetX(Enemy, EnemyX+120);
	ObjMove_SetX(GetPlayerObjectID, GetPlayerX+120);
	ObjMove_SetY(Enemy, EnemyY+16);
	ObjMove_SetY(GetPlayerObjectID, GetPlayerY+16);
	yield;
	ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/4, 7, 6);
	
	descent(i in 0..20){
		ObjRender_SetAlpha(frame, 255*i/19);
		yield;
	}
}

task CreateWarningCircleA1(render, x, y, duration){
	let scl = 0;
	
	ascent(i in 0..12){
		scl = i/11;
		RenderObject;
		yield;
	}
	
	loop(duration){
		RenderObject;
		if(!Hold(1)){break;}
	}
	
	descent(i in 0..12){
		scl = i/11;
		RenderObject;
		yield;
	}
	
	function RenderObject{
		let spin = rand(0,360);
		ObjRender_SetPosition(render, x, y, 0);
		ObjRender_SetScaleXYZ(render, scl, scl, 1);
		
		ObjRender_SetAngleZ(render, -spin);
		ObjSpriteList2D_AddVertex(render);
	}
}

task CreateSeijaBulletA1(X, Y, Spd1, Spd2, Dir, Gfx, Delay, Phase1, Phase2, AV){
	CreateSeijaBulletA2(X, Y, Spd1, Spd2, Dir, Gfx, Gfx+1000, Delay, Phase1, Phase2, AV)
}

task CreateSeijaBulletA2(X, Y, Spd1, Spd2, Dir, Gfx, Gfx2, Delay, Phase1, Phase2, AV){
	
	let a = CreateObjShotA1(X, Y, Spd1, Dir, Gfx, Delay);
	// ObjRender_SetBlendType(a, BLEND_SUBTRACT);
	if(!Hold(Phase1)){break;}
	X = ObjMove_GetX(a);
	Y = ObjMove_GetY(a);
	if(Obj_IsDeleted(a)){return;}
	ObjMove_SetY(a, -400);
	a = CreateObjShotA1(X, Y, Spd1, Dir, Gfx2, Delay);
	ObjMove_SetAngularVelocity(a,AV);
	// ObjShot_SetGraphic(a,Gfx2);
	// let S = 1.5;
	ObjMove_SetAcceleration(a,0.1);
	ObjMove_SetMaxSpeed(a,Spd2);
	ascent(i in 0..Delay){
		// ObjRender_SetScaleX(a,S);
		// ObjRender_SetScaleY(a,S);
		// S -= 0.5/Delay;
		if(!Hold(1)){break;}
	}
	if(!Hold(Phase2)){break;}
	X = ObjMove_GetX(a);
	Y = ObjMove_GetY(a);
	if(Obj_IsDeleted(a)){return;}
	ObjMove_SetY(a, -400);
	
	a = CreateObjShotA1(X, Y, Spd2, Dir, Gfx, Delay);
	// ObjRender_SetBlendType(a, BLEND_SUBTRACT);
	ObjMove_SetAngularVelocity(a,0);
	// ObjShot_SetGraphic(a,Gfx);
	// S = 1.5;
	ObjMove_SetAcceleration(a,-0.1);
	ObjMove_SetMaxSpeed(a,Spd1);
	// ascent(i in 0..Delay){
		// ObjRender_SetScaleX(a,S);
		// ObjRender_SetScaleY(a,S);
		// S -= 0.5/Delay;
		// if(!Hold(1)){break;}
	// }
}


function SpellInit(val){
	loop(145){yield;}
}

function BossInit(val){
	ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/2,GetStgFrameHeight/3,13, 5);
	loop(110){yield;}
}

function AttackInit(val){
	Hold(90);
}


task MoveLaser(obj, spd, delay){
	if(!Hold(delay)){return;}
	let ang = ObjStLaser_GetAngle(obj);
	let xm = spd*cos(ang);
	let ym = spd*sin(ang);
	while(!Obj_IsDeleted(obj)){
		ObjMove_SetPosition(obj, ObjMove_GetX(obj)+xm, ObjMove_GetY(obj)+ym);
		yield;
	}
}

function CreateQuickSlashLaserA1(x, y, ang, len, wid, graph, delay){
	let a = CreateStraightLaserA1(x, y, ang, len, 6, 2048, graph, 0);
	// let b = CreateStraightLaserA1(x, y, ang+180, 0, wid*0.4, 2048, graph, 0);
	// ObjRender_SetBlendType(a, BLEND_SUBTRACT);
	DoStuff(a);
	// DoStuff(b);
	return a;
	
	task DoStuff(a){	
		ObjStLaser_SetSource(a, false);
		
		let minwid = 6;
		let endwid = wid-minwid;
		
		let xm = cos(ang+180);
		let ym = sin(ang+180);
		
		
		let gtime = round(delay-argument*0.1);
		let wtime = round(2);
		
		ObjLaser_SetIntersectionWidth(a, 0);
		ObjShot_SetIntersectionEnable(a, false);
		
		while(!Obj_IsDeleted(a)){			
			ascent(i in 0..gtime){
				let mod = i/(gtime-1);
				yield;
			}
			
			ascent(i in 0..8){
				let mod = i/7;
				let nwid = minwid+endwid*mod;
				ObjLaser_SetRenderWidth(a, nwid);
				yield;
			}
			ObjLaser_SetIntersectionWidth(a, minwid+endwid);
			ObjShot_SetIntersectionEnable(a, true);
			loop(wtime){yield;}
			descent(i in 0..8){
				let mod = i/7;
				let nwid = minwid+endwid*mod;
				ObjLaser_SetRenderWidth(a, nwid);
				ObjLaser_SetIntersectionWidth(a, nwid);
				if(i == 4){
					ObjShot_SetIntersectionEnable(a, false);
				}
				yield;
			}
			Obj_Delete(a);
		}
	}
}



function CreateStopBulletA1(x, y, tx, ty, duration, spd, angmod, graph, delay){
	/*
	x = start x
	y = start y
	tx = end x
	ty = end y
	duration = time to get from start to end, also determines bullet speed after stopping
	spd = angular speed after stopping
	angmod = 1 or -1 (changes direction of rotation)
	graph = graphic
	del = delay before launching (after stopping)
	*/

	let dist = (((tx-x)^2+(ty-y)^2)^(1/2));
	let tang = atan2(ty - y, tx - x);
	let sspd = dist/duration;
	
	let a = CreateObjShotA1(x, y, sspd, tang, graph, 10);
	ObjMove_AddPatternA3(a, 10+duration, 0, NO_CHANGE, 0, 0, 0, graph);
	
	
	ObjMove_SetAcceleration(a, -(sspd/duration));
	ObjMove_SetMaxSpeed(a, 0);
	ObjMove_AddPatternA3(a, 10+duration+delay, NO_CHANGE, NO_CHANGE, (sspd/duration*1.5), (spd*0.0675)*angmod, sspd*1.5, graph);
	return a;
}

function CreateStopBulletB1(x, y, tx, ty, duration, spd, angmod, graph, delay){
	let dist = (((tx-x)^2+(ty-y)^2)^(1/2));
	let tang = atan2(ty - y, tx - x);
	let sspd = dist/duration;
	let a = CreateObjShotA1(x, y, sspd, tang, graph, 10);
	ObjMove_AddPatternA3(a, 10+duration, 0, NO_CHANGE, 0, 0, 0, graph);
	ObjMove_AddPatternA3(a, 10+duration+delay, NO_CHANGE, NO_CHANGE, (sspd/duration*1.5), (spd*0.0675)*angmod, sspd*1.5, graph);
	return a;
}


function CreateWarpShotA1(x, y, spd, ang, graph, delay, count){
	let a = CreateShotA1(x, y, spd, ang, graph, delay);
	GiveCollision(a);
	Obj_SetValue(a, "Damage", 23.5+argument/3);
	DoStuff;
	return a;
	
	task DoStuff{
		let Warp = false;
		
		let xm = spd*cos(ang);
		let ym = spd*sin(ang);
		
		while(count > 0 && !Obj_IsDeleted(a) && !EnemyDead){
			x = ObjMove_GetX(a);
			y = ObjMove_GetY(a);
			
			if(x > GetStgFrameWidth){x-=GetStgFrameWidth;Warp = true;}
			if(x < 0){x+=GetStgFrameWidth;Warp = true;}
			if(y > GetStgFrameHeight){y-=GetStgFrameHeight;Warp = true;}
			if(y < 0){y+=GetStgFrameHeight;Warp = true;}
			
			if(Warp){
				ObjMove_SetPosition(a, round(x), round(y));
				Warp = false;
				count--;
			}
			
			if(!Hold(1)){break;}
		}
		while(!Obj_IsDeleted(a)){
			x = ObjMove_GetX(a);
			y = ObjMove_GetY(a);
			if(!Hold(1)){break;}
		}
		ObjShot_BulletBreak(x, y, graph);
	}
	
	function GetNewCoordinate(nx, ny){
		if(nx > GetStgFrameWidth){return [0, ny];}
		if(nx < 0){return [GetStgFrameWidth, ny];}
		if(ny < 0){return [nx, GetStgFrameHeight];}
		if(ny > GetStgFrameHeight){return [nx, 0];}
		return [-1];
	}
}


let B_NORMAL = 0;
let B_WATER = 1;
let B_STICKY = 2;
let B_WEAPON = 3;
let B_BLUNTOBJ = 4;

function ObjShot_SetBulletTypeA1(obj, type){
	Obj_SetValue(obj, "BulletClass", [type]);
}

function ObjShot_GetBulletTypeA1(obj){
	return Obj_GetValueD(obj, "BulletClass", [B_NORMAL])[0];
}

function ObjShot_CheckIfTypeA1(obj, type){
	let types = Obj_GetValueD(obj, "BulletClass", [B_NORMAL]);
	if(length(types) == 1){return types[0] == type;}
	
	
	
	ascent(i in 0..length(types)){
		if(types[0] == type){return true;}
	}
	return false;
}

task CreateWarningLaserLineSet(x, y, ang, wid, dbreak){
	let xm = cos(ang+90);
	let ym = sin(ang+90);
	ascent(i in 0..20){
		let dmod = wid/19*i;
		CreateWarningLaserA1(EnemyX+xm*dmod, EnemyY+ym*dmod, ang, 20, 512, 40, 50, 505);
		CreateWarningLaserA1(EnemyX-xm*dmod, EnemyY-ym*dmod, ang, 20, 512, 40, 50, 505);
		if(!Hold(dbreak)){break;}
	}
}



task CreateSwordZone(enemy, irad, rspd){
	let x = ObjMove_GetX(enemy);
	let y = ObjMove_GetY(enemy);

	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, 0.3);
	ObjPrim_SetTexture(obj, img_CircleA);
	ObjSprite2D_SetSourceRect(obj, 0, 0, 1024, 1024);
	ObjSprite2D_SetDestCenter(obj);
	ObjRender_SetPosition(obj, x, y, 0);
	ObjRender_SetColor(obj, 255, 32, 32);
	
	ObjRender_SetAlpha(obj, 96);
	
	let crad = 0;
	let kill = 0;
	
	while(!Obj_IsDeleted(enemy) && !EnemyDead){
		x = ObjMove_GetX(enemy);
		y = ObjMove_GetY(enemy);
		ObjRender_SetPosition(obj, x, y, 0);
		
		let scl = crad/1024;
		ObjRender_SetScaleXYZ(obj, scl, scl, 0);
		
		let dist = (irad-crad);
		let mod = absolute(dist)/dist;
		if(dist < rspd){crad = irad}else{crad += rspd*mod;}
		
		kill++;
		if(kill > 0){
			if(GetDistance(x, y, GetPlayerX, GetPlayerY) < crad/2){
				kill = -29+argument/10;
				let rang = rand(0, 360);
				let srang = rang+rand(15, 50);
				CreateSlashA1(GetPlayerX+600*cos(rang), GetPlayerY+600*sin(rang), rang+180, 4000, 20, 10, 1001, 0);
				let swid = 48+argument/2;
				let sswid = swid/3;
				CreateSlashA1(GetPlayerX+swid*cos(srang+90), GetPlayerY+swid*sin(srang+90), srang-90, swid*2, 16, 10, 11, 0);
				// CreateSlashA1(GetPlayerX-sswid*cos(srang+45), GetPlayerY-sswid*sin(srang+45), srang+45, sswid*2.1, 6+argument/5, 10, 11, 0);
				// CreateSlashA1(GetPlayerX-sswid*cos(srang-45), GetPlayerY-sswid*sin(srang-45), srang-45, sswid*2.1, 6+argument/5, 10, 11, 0);
			}
		}
		
		
		yield;
	}
	descent(i in 0..10){
		let scl = crad/1024/9*i;
		ObjRender_SetScaleXYZ(obj, scl, scl, 0);
		yield;
	}
	Obj_Delete(obj);
}


task CreateSlashA1(x, y, ang, len, wid, del, graph, delay){	
	let obj = CreateStraightLaserA1(x, y, ang, len, wid, 9999, graph, 0);
	ObjRender_SetBlendType(obj, BLEND_ADD_ARGB);
	ObjShot_SetIntersectionEnable(obj, true);
	ObjLaser_SetInvalidLength(obj, 0, 0);
	ObjStLaser_SetSource(obj, false);
	
	Obj_SetValue(obj, "Damage", 35+(argument^0.5)*10);
	
	
	ascent(i in 0..5){
		let nwid = wid/4*i;
		ObjShot_SetIntersectionLine(obj, x, y, x+len*cos(ang), x+len*sin(ang), wid);
		ObjLaser_SetRenderWidth(obj, nwid);
		ObjLaser_SetIntersectionWidth(obj, nwid*3);
		yield;
	}
	loop(del+delay){yield;}
	descent(i in 0..4){
		let nwid = wid/5*i;
		ObjLaser_SetRenderWidth(obj, nwid);
		ObjLaser_SetIntersectionWidth(obj, nwid*3);
		yield;
	}
	Obj_Delete(obj);
	// Obj_Delete(shot);
	
}


function CreateExplodeLaserA1(x, y, ang, wid, graph, wtime){
	let a = CreateStraightLaserA1(x, y, ang, 0, wid*0.4, 2048, graph, 0);
	// let b = CreateStraightLaserA1(x, y, ang+180, 0, wid*0.4, 2048, graph, 0);
	ObjRender_SetBlendType(a, BLEND_ADD_ARGB);
	DoStuff(a);
	// DoStuff(b);
	return a;
	
	task DoStuff(a){
		PlaySoundO2(laser_2, 45);
		ObjStLaser_SetSource(a, false);
		let minlen = (16+argument*0.4)/2;
		let intlen = minlen*3;
		let endlend = 550+argument*3-(minlen+intlen);
		
		let minwid = wid*0.75;
		let endwid = wid-minwid;
		
		let xm = cos(ang+180);
		let ym = sin(ang+180);
		
		
		let gtime = round(60-argument*0.2);
		// let wtime = round(3);
		while(!Obj_IsDeleted(a)){			
			ascent(i in 0..gtime){
				let mod = i/(gtime-1);
				let nlen = minlen+intlen*mod;
				ObjMove_SetPosition(a, x+nlen*xm, y+nlen*ym);
				ObjLaser_SetLength(a, nlen*2);
				if(!Hold(1)){break;}
			}
			
			PlaySoundO2(laser_1, 28);
			ascent(i in 0..12){
				let mod = i/11;
				let nlen = minlen+intlen+endlend*mod;
				let nwid = minwid+endwid*mod;
				ObjMove_SetPosition(a, x+nlen*xm, y+nlen*ym);
				ObjLaser_SetLength(a, nlen*2);
				ObjLaser_SetRenderWidth(a, nwid);
				ObjLaser_SetIntersectionWidth(a, nwid*0.66);
				if(!Hold(1)){break;}
			}
			loop(wtime){if(!Hold(1)){break;};}
			descent(i in 0..12){
				let mod = i/11;
				let nlen = (minlen+intlen+endlend)*mod;
				let nwid = minwid+endwid*mod;
				ObjMove_SetPosition(a, x+nlen*xm, y+nlen*ym);
				ObjLaser_SetLength(a, nlen*2);
				ObjLaser_SetRenderWidth(a, nwid);
				ObjLaser_SetIntersectionWidth(a, nwid*0.66);
				if(!Hold(1)){break;}
			}
			Obj_Delete(a);
		}
	}
}

/*
x1 and y1 determine the curve
x2 and y2 is the destination
*/

function GetRealBoss{
	if(length(GetEnemyBossObjectID) > 0){
		return GetEnemyBossObjectID[0];
	}
	return Enemy;
}

function GetRealBossA2(obj){
	if(length(GetEnemyBossObjectID) > 0){
		return GetEnemyBossObjectID[0];
	}
	return obj;
}

task SetAttackTimer(time){
	if(!IsPairingActive){
		ObjEnemyBossScene_SetSpellTimer(objScene, time*60);
	}else{
		if(GetBossRank == 0){
			ObjEnemyBossScene_SetSpellTimer(objScene, time*60);
		}
	}
}

task SetInvincibilityB1(delay, shotfactor, spellfactor){
	if(IsPairingActive && GetBossRank == 1){
		return;
	}
	ObjEnemy_SetDamageRate(GetRealBoss, 0, 0);	
	loop(delay){yield;}
	ObjEnemy_SetDamageRate(GetRealBoss, shotfactor, spellfactor/max(1, argument/20-2));
}

function IsPairingActive{
	if(GetScriptArgumentCount > 0){
		return GetScriptArgument(2);
	}
	return 0;
}

function GetBossSide{
	return (-1+2*GetBossRank);
}

function GetBossRank{
	if(GetScriptArgumentCount > 0){
		return GetScriptArgument(1);
	}
	return 0;
}

function Obj_DeleteBoss{
	WriteLog("----------fix this later");
	Obj_Delete(Enemy);
	return;
	
	if(GetScriptArgumentCount > 0){
		return;
	}
	
	if(ObjEnemyBossScene_GetInfo(objScene, INFO_REMAIN_STEP_COUNT) == 0){
		if(ObjEnemyBossScene_GetInfo(objScene, INFO_ACTIVE_STEP_TOTAL_LIFE) <= 0){
			ExplosionB2(Enemy,"CHERRY",[192, 192, 192],[192, 192, 192]);
			loop(90){yield;}
		}
	}else{Obj_Delete(Enemy);}
	
}

task SetEnemyAnimationDataA1(objEnemy, x, y){
	Obj_SetValue(objEnemy, "Rects", [x, y]);
}


function wait(w) { 
	loop(w) { yield; }
	
	while(EnemyDead){yield;}
}

task GiveBulletScreenDefyA1(obj){
	while(!Obj_IsDeleted(obj)){
		ObjMove_SetPosition(obj, ObjMove_GetX(obj)+ScreenMoveSpeed[0], ObjMove_GetY(obj)+ScreenMoveSpeed[1]);
		yield;
	}
}



task AntiGravityFieldSquareA1(obj, gain, decay, l, t, r, b){
	
	let lx = GetPlayerX;
	let ly = GetPlayerY;
	
	let dmod = 1;
	
	let sx = 0;
	let sy = 0;
	let rs = 0;
	
	let tsx = 5;
	let tsy = 5;
	
	let xmod = 1;
	let ymod = 1;
	
	let IsInBox = false;
	let MovePlayer = 0;
	
	// StartSlow(TARGET_ALL, 5);

	while(!Obj_IsDeleted(obj)){
		sx = min(tsx, max(sx-decay*dmod, 0));
		sy = min(tsy, max(sy-decay*dmod, 0));
		
		if(GetPlayerState != STATE_NORMAL){sx = 0; sy = 0;}

		if(CheckInsideBox(GetPlayerX, GetPlayerY, l, t, r, b)){
			IsInBox = true;
		}else{IsInBox = false; sx = 0; sy = 0;}
		
		
		let px = absolute(GetPlayerX-lx);
		let opx = GetPlayerX-lx;
		if(px > 0){xmod = px/opx;}
		else if(sx == 0){xmod = 0;}
		
		let py = absolute(GetPlayerY-ly);
		let opy = GetPlayerY-ly;
		if(py > 0){ymod = py/opy;}
		else if(sy == 0){ymod = 0;}
		
		
		if((GetVirtualKeyState(VK_LEFT) != KEY_FREE || GetVirtualKeyState(VK_RIGHT) != KEY_FREE)
		&& !(GetVirtualKeyState(VK_LEFT) == KEY_HOLD && GetVirtualKeyState(VK_RIGHT) == KEY_HOLD)){
			if(lx != GetPlayerX){
				if(px < sx){
					tsx = sx;
					sx -= decay*2;
					MovePlayer = 2;
				}else{
					tsx = px;
					sx = min(sx+gain, px);
				}
			}
		}else if(IsInBox){
			MovePlayer = 1;
		}
		
		if((GetVirtualKeyState(VK_UP) != KEY_FREE || GetVirtualKeyState(VK_DOWN) != KEY_FREE)
		&& !(GetVirtualKeyState(VK_UP) == KEY_HOLD && GetVirtualKeyState(VK_DOWN) == KEY_HOLD)){
			if(ly != GetPlayerX){
				if(py < sy){
					tsy = sy;
					sy -= decay;
					MovePlayer = 2;
				}else{
					tsy = py;
					sy = min(sy+gain, py);
				}
			}
		}else if(IsInBox){
			MovePlayer = 1;
		}
		
		if(MovePlayer > 0){
			rs = max(sx, sy);
			ObjMove_SetPosition(GetPlayerObjectID, GetPlayerX+(sx-px)*xmod, GetPlayerY+(sy-py)*ymod);
			MovePlayer = 0;
		}
		
		lx = GetPlayerX;
		ly = GetPlayerY;
		yield;
	}
}



task ShiftScreenA1(xdiff, ydiff, time){
	let sx = GetStgFrameWidth;
	let sy = GetStgFrameHeight;
	
	ShiftScreenB1(
	GetStgFrameLeft+xdiff, GetStgFrameTop+ydiff, 
	GetStgFrameLeft+sx+xdiff, GetStgFrameTop+sy+ydiff, 
	time);
}

task ShiftScreenB1(nl, nt, nr, nb, time){


	let sl = GetStgFrameLeft;
	let st = GetStgFrameTop;
	let sr = sl + GetStgFrameWidth;
	let sb = st + GetStgFrameHeight;
	
	let dl = nl-sl;
	let dt = nt-st;
	let dr = nr-sr;
	let db = nb-sb;
	
	let lx = 0;
	let ly = 0;
	let cx = 0;
	let cy = 0;
	
	let rx = Get2DCameraX;
	let ry = Get2DCameraY;
	
	Obj_SetValue(GetPlayerObjectID, "MasterFileSpecialScreenShakeCoord", [rx, ry]);
	
	ScreenMoveSpeed = [dl/time, dt/time];
	
	let shake = 7;
	let sstart = 44;
	
	ascent(i in 0..time){
		// let mod = sin(i/(time-1)*90);
		let mod = i/(time-1);
		cx = dl*mod;
		cy = dt*mod;
		SetStgFrame(sl+cx, st+cy, sr+dr*mod, sb+db*mod, 20, 80);
		Obj_SetValue(GetPlayerObjectID, "MasterFileClipXOffset", sl+cx-32);
		Obj_SetValue(GetPlayerObjectID, "MasterFileClipYOffset", st+cy-16);
		
		// ObjMove_SetPosition(GetPlayerObjectID, GetPlayerX+(lx-cx), GetPlayerY+(ly-cy));
		
		rx-=(lx-cx);
		ry-=(ly-cy);
		Set2DCameraFocusX(rx+min(shake, rand(-sstart, sstart)/(i+2)));
		Set2DCameraFocusY(ry+min(shake, rand(-sstart, sstart)/(i+2)));
		Obj_SetValue(GetPlayerObjectID, "MasterFileSpecialScreenShakeCoord", [rx, ry]);
		
		GetScreenOffsetX = rx - 192;
		
		lx = cx;
		ly = cy;
		yield;
	}
	ScreenMoveSpeed = [0, 0];
	descent(i in 0..20){
		let mod = i/(19);
		Set2DCameraFocusX(rx+rand(-shake, shake)*mod);
		Set2DCameraFocusY(ry+rand(-shake, shake)*mod);
		yield;
	}
	GetScreenOffsetX = rx - 192;
	Set2DCameraFocusX(rx);
	Set2DCameraFocusY(ry);
}

function InitRender(obj, pri, image){
	if(obj!=ID_INVALID){DoOtherStuff;return obj;}

	obj = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	Obj_SetRenderPriority(obj, pri);
	ObjPrim_SetTexture(obj, image);
	
	DoStuff;
	return obj;
	
	
	task DoStuff{
		while(!Obj_IsDeleted(obj)){
			ObjSpriteList2D_ClearVertexCount(obj);
			yield;
		}
	}
	task DoOtherStuff{
		while(!Obj_IsDeleted(Enemy)){
			ObjSpriteList2D_ClearVertexCount(obj);
			yield;
		}
		loop(60){
			ObjSpriteList2D_ClearVertexCount(obj);
			yield;
		}
	}
}

function CreateYinYangY2(x, y, xoff, yoff){
	//x,y coordinates
	//l,
	let yin = ObjEnemy_Create(OBJ_ENEMY);
	ObjMove_SetPosition(yin, x, y);
	ObjEnemy_Regist(yin);
	ObjEnemy_SetLife(yin, 100);


	let spin = 0;
	let scl = 1/8;
	
	DoFunctions;
	
	return yin;
	
	
	task DoFunctions{
		yield;
		while(ObjEnemy_GetInfo(yin, INFO_LIFE) > 0 && !EnemyDead){
			if(CheckOutsideScreenA1(yin, 64)){
				Obj_Delete(yin);
				return;
			}
			x = ObjMove_GetX(yin);
			y = ObjMove_GetY(yin);
			scl = Obj_GetValueD(yin, "YinScale", scl);
			ObjEnemy_SetIntersectionCircleToShot(yin, x, y, 64*scl);
			ObjEnemy_SetIntersectionCircleToPlayer(yin, x, y, 58*scl);
			RenderObject;
			// scl = 0.7+0.3*cos(spin);
			yield;
		}
		
		ExplosionA1(yin, Obj_GetValueD(yin, "YinGraph", "CHERRY"),
			Obj_GetValueD(yin, "YinColor1", [0,0,128]),
			Obj_GetValueD(yin, "YinColor2", [0,0,128]));
		Obj_Delete(yin);
	}
	
	function RenderObject{
		ObjRender_SetPosition(EnemyRender, x, y, 0);
		let mod = (1-1/8+scl);
		spin+=6/(mod*6-5);
		ObjRender_SetScaleXYZ(EnemyRender, scl, scl, 1);
		
		ObjRender_SetAlpha(EnemyRender, 255);
		ObjRender_SetColor(EnemyRender, 255, 255, 255);
		ObjRender_SetAngleZ(EnemyRender, -spin);
		ObjSpriteList2D_SetSourceRect(EnemyRender, xoff, yoff, 256+xoff, 256+yoff);
		ObjSpriteList2D_SetDestCenter(EnemyRender);
		ObjSpriteList2D_AddVertex(EnemyRender);
		
		let amod = 255/(mod*3-2);
		ObjRender_SetAlpha(EnemyRender, amod);
		ObjRender_SetColor(EnemyRender, amod, amod, amod);
		ObjRender_SetAngleZ(EnemyRender, spin);
		ObjSpriteList2D_SetSourceRect(EnemyRender, 256+xoff, yoff, 512+xoff, 256+yoff);
		ObjSpriteList2D_SetDestCenter(EnemyRender);
		ObjSpriteList2D_AddVertex(EnemyRender);
	}
}

function SetYinExplosionColor(obj, graphic, r1, g1, b1, r2, g2, b2){
	Obj_SetValue(obj, "YinGraph", graphic);
	Obj_SetValue(obj, "YinColor1", [r1,g1,b1]);
	Obj_SetValue(obj, "YinColor2", [r2,g2,b2]);
}


task PlayMusicG1(name, force, start, end){
	let num = 0;
	if(force){num = 1;}
	NotifyEventAll(EV_USER+32, name~"^"~IntToString(num)~"^"~IntToString(start)~"^"~IntToString(end));
}

function GiveCollision(objShot){
	if(!IsPlayerSpellActive){
		ObjShot_SetIntersectionEnable(objShot, false);
		Obj_SetValue(objShot, "g_Coll", false);
	}else{ObjShot_SetIntersectionEnable(objShot, true);Obj_SetValue(objShot, "g_Coll", true);}
}


function CreateCollisionShotA1(x, y, spd, ang, grp, del){
	let a = CreateShotA1(x, y, spd, ang, grp, del);
	GiveCollision(a);
	return a;
}

function CreateCollisionShotA2(x, y, spd, ang, acc, maxs, grp, del){
	let a = CreateShotA2(x, y, spd, ang, acc, maxs, grp, del);
	GiveCollision(a);
	return a;
}



task GrantSuctionPropertyA1(obj, pgrav, bgrav, bdelpoint){
	// bgrav = 16+grav*1.2;
	let x = 0;
	let y = 0;
	let w = 1; //test
	WriteLog("Activated");
	while(!Obj_IsDeleted(obj)){
		
		x = ObjRender_GetX(obj);
		y = ObjRender_GetY(obj);
	
		let dtp = GetDistance(GetPlayerX, GetPlayerY, x, y);
		if(dtp < pgrav){
			let atp = AngleToPlayer(x, y);
			let mov = max(0, (pgrav-dtp-GetPlayerInvincibilityFrame*3)/200);
			ObjMove_SetPosition(GetPlayerObjectID, GetPlayerX-mov*cos(atp), GetPlayerY-mov*sin(atp)); 
		}
		
		
		let barray = GetShotIdInCircleA2(x, y, bdelpoint, TARGET_ENEMY);
		ascent(i in 0..length(barray)){
			let objShot = barray[i];
			if(Obj_GetValueD(objShot, "Suction", true)){Obj_Delete(objShot);}
		}
		
		
		barray = GetShotIdInCircleA2(x, y, bgrav, TARGET_ENEMY);
		ascent(i in 0..length(barray)){
			let objShot = barray[i];
			if(!ObjShot_IsSpellResist(objShot)&&Obj_GetValueD(objShot, "Suction", true)){
				let shotspd = ObjMove_GetSpeed(objShot);
				let dts = GetDistance(ObjMove_GetX(objShot), ObjMove_GetY(objShot), x, y);
				let A = ObjMove_GetAngle(objShot);
				let dir = atan2(y - ObjMove_GetY(objShot), x - ObjMove_GetX(objShot));
				// let diff = NormalizeNewAngle(dir - A);
				// let intensity = (bgrav-dts)/500*max(1, shotspd/4);
				
				// let diffAbs = (|diff|);
				// if(diffAbs <= intensity) {
					// A = dir;
				// }else{
					// A += intensity * diff / diffAbs;
				// }
					
				// let dir = atan2(ty - y, tx - x);
				let diff = NormalizeNewAngle(dir - A);
				let diffAbs = (|diff|);
				
				A += (max(1, w)*diff/70+w*diff/diffAbs) * (1+125/dts);
				
				
				ObjMove_SetAngle(objShot, A);
				//0.015 percent speed for lunatic
				ObjMove_SetSpeed(objShot, shotspd*(1+0.01/max(1, shotspd)));
			}
		}
		
		
		
		yield;
	}
}

function NormalizeNewAngle(nang){
	while(nang>=180){nang-=360;}
	while(nang<-180){nang+=360;}
	return nang;
}

function NormalizeNewAngleB(nang){
	return nang%360;
}


task ObjMove_SetDestAtWeightLimitedA1(objEnemy, x, y, maxdis, bdivx, bdivy, weight, maxspd){ 
	let ex = ObjMove_GetX(objEnemy);
	let ey = ObjMove_GetY(objEnemy);
	let dist = min(maxdis, GetDistance(ex, ey, x, y));
	let dang = AngleToLocation(ex, ey, x, y);
	let nx = max(GetStgFrameWidth/bdivx, min(GetStgFrameWidth/bdivx*(bdivx-1), ex+dist*cos(dang)));
	let ny = max(GetStgFrameHeight/bdivy, min(GetStgFrameHeight/bdivy*(bdivy/3), ey+dist*sin(dang)));
	ObjMove_SetDestAtWeight(objEnemy, nx, ny, weight, maxspd);
}

task ObjMove_SetDestAtWeightTempTest(obj, x2, y2, weight, maxspd){

	let curX = ObjMove_GetX(obj);
	let curY = ObjMove_GetY(obj);
	
	let distanceToTarget = GetDistance(curX, curY, x2, y2);

	let curSpd = 0;
	let angleToTarget = AngleToLocation(curX, curY, x2, y2);
	let xm = cos(angleToTarget);
	let ym = sin(angleToTarget);
	
	ObjMove_SetAngle(obj, angleToTarget);

	while(distanceToTarget > 1){
		distanceToTarget = GetDistance(curX, curY, x2, y2);
		curSpd = min(distanceToTarget/weight, maxspd);
		curX += curSpd*xm;
		curY += curSpd*ym;
		// ObjMove_SetPosition(obj, curX, curY);
		ObjMove_SetSpeed(obj, curSpd);
		yield;
	}
		ObjMove_SetSpeed(obj, 0);
}


task CreateStarAnimationA1(x, y, scl, iangle, rangle, length, alph, blendtype, r, g, b, delay){
	//iangle - initial; rangle - ending angle, relative to initial
	let obj = CreateSimple2DImageA1(0.7, FuncSrc~"img/Masks/star4s.png");
	ObjRender_SetBlendType(obj, blendtype);
	ObjRender_SetAlpha(obj, alph);
	ObjRender_SetColor(obj, r, g, b);
	ObjRender_SetPosition(obj, x, y, 0);
	
	let cscl = 0;
	let cang = iangle;	
	ascent(i in 0..length){
		cscl = scl*sin(180/length*i);
		cang += rangle/length;
		ObjRender_SetAngleZ(obj, cang);
		ObjRender_SetScaleXYZ(obj, cscl, cscl, 0);
		yield;
	}
	Obj_Delete(obj);
}

task ObjMove_MoveBezierCurve(obj,s,x1,y1,x2,y2){
	let t = 0;
	let p = [ObjMove_GetX(obj),(x1),x2];
	let p2 = [ObjMove_GetY(obj),(y1),y2];
	let x = 0;
	let y = 0;
	let speed = s/1000;
	while(t<=1){
		x = (1 - t) * (1 - t) * p[0] + 2 * (1 - t) * t * p[1] + t * t * p[2];
		y = (1 - t) * (1 - t) * p2[0] + 2 * (1 - t) * t * p2[1] + t * t * p2[2];
		t+=speed;
		ObjMove_SetPosition(obj,x,y);
		yield;
	}
	ObjMove_SetPosition(obj,x2,y2);
}
task ObjMove_MoveBezierCurveB1(obj,duration,x1,y1,x2,y2){
	let t = 0;
	let lx = ObjMove_GetX(obj);
	let ly = ObjMove_GetY(obj);
	let p = [x2,(x1),lx];
	let p2 = [y2,(y1),ly];
	let x = 0;
	let y = 0;
	
	ObjMove_SetSpeed(obj, 1);
	
	ascent(i in 0..duration){
		if(ObjEnemy_GetInfo(obj, INFO_LIFE) <= 0){break;}
		let t = 1-sin(90*i/(duration-1));
		x = (1 - t) * (1 - t) * p[0] + 2 * (1 - t) * t * p[1] + t * t * p[2];
		y = (1 - t) * (1 - t) * p2[0] + 2 * (1 - t) * t * p2[1] + t * t * p2[2];
		
		ObjMove_SetPosition(obj,x,y);
		// if(ObjMove_GetSpeed(obj) > 0.3){break;}
		ObjMove_SetAngle(obj, AngleToLocation(lx, ly, x, y));
		
		lx = x;
		ly = y;
		
		yield;
	}
	ObjMove_SetSpeed(obj, 0);
	// ObjMove_SetPosition(obj,x2,y2);
}
task ObjRender_MoveBezierCurveB1(obj,duration,x1,y1,x2,y2){
	let t = 0;
	let lx = ObjRender_GetX(obj);
	let ly = ObjRender_GetY(obj);
	let p = [x2,(x1),lx];
	let p2 = [y2,(y1),ly];
	let x = 0;
	let y = 0;
	
	ascent(i in 0..duration){	
		let t = 1-sin(90*i/(duration-1));
		x = (1 - t) * (1 - t) * p[0] + 2 * (1 - t) * t * p[1] + t * t * p[2];
		y = (1 - t) * (1 - t) * p2[0] + 2 * (1 - t) * t * p2[1] + t * t * p2[2];
		ObjRender_SetPosition(obj,x,y,0);
		// if(ObjMove_GetSpeed(obj) > 0.3){break;}
		lx = x;
		ly = y;
		
		yield;
	}
}
function CreateBezierCurveMouseTest{
	let obj = ObjPrim_Create(OBJ_PRIMITIVE_2D);
	ObjPrim_SetPrimitiveType(obj, PRIMITIVE_LINESTRIP);
	ObjPrim_SetTexture(obj, NULL);
	ObjPrim_SetVertexCount(obj, 32);
	ObjRender_SetAlpha(obj, 255);
	Obj_SetRenderPriority(obj, 0.6);
	ObjRender_SetColor(obj, 16, 212, 212);
	
	let x1 = 64;
	let y1 = 24;
	let x2 = 64;
	let y2 = 64;
	let p = [GetStgFrameWidth/2,(x1),x2];
	let p2 = [GetStgFrameHeight/6,(y1),y2];
	
	while(!Obj_IsDeleted(obj)){
		if(GetKeyState(KEY_1) == KEY_PUSH){
			p[0] = GetMouseX-GetStgFrameLeft;
			p2[0] = GetMouseY-GetStgFrameTop;
		}
		if(GetKeyState(KEY_2) == KEY_PUSH){
			x1 = GetMouseX-GetStgFrameLeft;
			y1 = GetMouseY-GetStgFrameTop;
			p[1] = x1;
			p2[1] = y1;
		}
		if(GetKeyState(KEY_3) == KEY_PUSH){
			p[1] = GetMouseX+x1-GetStgFrameLeft;
			p2[1] = GetMouseY+y1-GetStgFrameTop;
			
			p[2] = GetMouseX-GetStgFrameLeft;
			p2[2] = GetMouseY-GetStgFrameTop;
		}
		if(GetKeyState(KEY_5) == KEY_PUSH){
			WriteLog(p);
			WriteLog(p2);
		}
		ascent(i in 0..32){
			let t = i/31;
			let x = (1 - t) * (1 - t) * p[0] + 2 * (1 - t) * t * p[1] + t * t * p[2];
			let y = (1 - t) * (1 - t) * p2[0] + 2 * (1 - t) * t * p2[1] + t * t * p2[2];
			ObjPrim_SetVertexPosition(obj, i, x, y, 0);
		}
		yield;
	}
}


task CreateScreenCoverA1(dobj, blend, alph, sint, eout, r, g, b){
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, blend);
	Obj_SetRenderPriority(obj, 0.6);
	ObjPrim_SetTexture(obj, img_ScreenCover);
	ObjSprite2D_SetSourceRect(obj, 0, 0, 384, 448);
	ObjSprite2D_SetDestRect(obj, 0, 0, 384, 448);
	
	ascent(i in 0..sint){
		ObjRender_SetAlpha(obj, alph/sint*i);
		yield;
	}
	
	while(!Obj_IsDeleted(dobj)){
		yield;
	}
	
	descent(i in 0..eout){
		let mod = i/sint;
		ObjRender_SetAlpha(obj, alph*mod);
		ObjRender_SetColor(obj, r*mod, g*mod, b*mod);
		yield;
	}
	
	Obj_Delete(obj);
}


task CreateShadowB1(tobj, x, y, spd, ang, scl, alph, intr, len, del){	
	let obj = CreateSimple2DImageA1(0.6, img_Cloud);
	ObjRender_SetBlendType(obj, BLEND_SUBTRACT);
	ObjRender_SetScaleXYZ(obj, scl, scl, 1);
	let a = rand(0, 360);
	let am = rand(-0.5, 0.5);
	let xm = spd*cos(ang);
	let ym = spd*sin(ang);
	let s = 0;
	
	ascent(i in 0..intr){
		ObjRender_SetAlpha(obj, alph/intr*i);
		PerformRenderActions;
	}
	
	ascent(i in 0..len){
		if(Obj_IsDeleted(tobj)){break;}
		PerformRenderActions;
	}
	
	descent(i in 0..del){
		ObjRender_SetAlpha(obj, alph/del*i);
		PerformRenderActions;
	}
	Obj_Delete(obj);
	
	
	sub PerformRenderActions{
		ObjRender_SetPosition(obj, x, y, 0);
		ObjRender_SetAngleZ(obj, a);
		x+=xm;
		y+=ym;
		a+=am;
		yield;
	}
}


function CreateDarkerBulletA1(x, y, spd, ang, graph, del){
	let obj = CreateObjShotA1(x, y, spd, ang, graph, del);
	CreateDarkerBulletA1_Wrapper(obj, x, y, spd, ang);
	return obj;
}

task CreateDarkerBulletA1_Wrapper(obj, x, y, spd, ang){
	if(quality == 0){return;}
	let fskip = 0;
	while(!Obj_IsDeleted(obj)){
		x = ObjMove_GetX(obj);
		y = ObjMove_GetY(obj);
		fskip++;
		if(fskip>=11-quality){
			loop(round(quality*0.5+0.01)){
				SimpleShadow(obj, x, y);
			}
			fskip = 0;
		}
		yield;
	}
}

task SimpleShadow(obj, x, y){
	CreateShadowB1(obj, x, y, rand(0.1, 0.3), rand(0, 360), rand(0.1, 0.2), 144, 8, rand(9, 15), 33);
}


task CreateVoidSlashA1(x, y, spd, ang, angwid, rad, radadd, mod, len, shots, ainc, bul){
	/*	angwid = width offset of the angle
		rad = radius
		radadd = amount to add to radius, this is relative and is peaked at len/2
		mod = starting point mod, 1 or -1
		len = length in frames
		shots = amount of shots fired in slash
		bul = graphic 
		
		this function is actually broken...  but i dont want to break the prior spellcards
		*/
	
	PlaySoundB1("se_slash", 83);
	
	let shrate = 5-quality;
	let arbit = 0;
	let yskip = 0;
	if(shots/len > 1){
		arbit = shots/len;
	}
	
	angwid *= mod;
	let sang = ang-angwid/2;
	
	
	ascent(i in 0..shots){
		let lang = sang+angwid/len*i;
		let lrad = rad+radadd*sin(180/len*i);
		
		let lx = x+lrad*cos(lang);
		let ly = y+lrad*sin(lang);
		
		let a = CreateObjShotA1(lx, ly, spd/8, lang+ainc*i, bul, 7);
		ObjMove_AddPatternA2(a, 70, NO_CHANGE, NO_CHANGE, spd/7/15, 0, spd);
		ObjShot_AddDeletionFrameA1(a,160);
		PlaySoundB1("se_tan00", 27);
		
		if(i%shrate==0){SimpleShadow(Enemy, lx, ly);}
		
		
		yskip++;
		if(yskip >= arbit){
			if(!Hold(ceil(len/shots))){break;}
			yskip = 0;
		}
	}
	
}

task CreateVoidSlashA2(x, y, spd, ang, angwid, rad, radadd, mod, wtim, len, shots, ainc, bul){
	/*	angwid = width offset of the angle
		rad = radius
		radadd = amount to add to radius, this is relative and is peaked at len/2
		mod = starting point mod, 1 or -1
		len = length in frames
		shots = amount of shots fired in slash
		bul = graphic */
	
	PlaySoundB1("se_slash", 83);
	
	let shrate = 5-quality;
	let arbit = 0;
	let yskip = 0;
	if(shots/len > 1){
		arbit = shots/len;
	}
	
	angwid *= mod;
	let sang = ang-angwid/2;
	
	
	ascent(i in 0..shots){
		let lang = sang+angwid/(shots-1)*i;
		let lrad = rad+radadd*sin(180/len*i);
		
		let lx = x+lrad*cos(lang);
		let ly = y+lrad*sin(lang);
		
		let a = CreateObjShotA1Dist(lx, ly, spd/8, lang+ainc*i, bul, 7, 32);
		ObjMove_AddPatternA2(a, wtim, NO_CHANGE, NO_CHANGE, spd/7/15, 0, spd);
		ObjShot_AddDeletionFrameA1(a,160);
		PlaySoundB1("se_tan00", 27);
		
		if(i%shrate==0){SimpleShadow(Enemy, lx, ly);}
		
		
		yskip++;
		if(yskip >= arbit){
			if(!Hold(ceil(len/shots))){break;}
			yskip = 0;
		}
	}
}

function CreateObjShotA1Dist(x, y, spd, ang, graph, delay, dist){
	if(GetDistance(x,y,GetPlayerX,GetPlayerY) > dist){
		return CreateObjShotA1(x, y, spd, ang, graph, delay)
	}
	return ID_INVALID;
}

task CheckIfNearPlayer(a, dist){
	if(GetDistance(ObjMove_GetX(a),ObjMove_GetY(a),GetPlayerX,GetPlayerY) < dist){
		Obj_Delete(a);
	}
}

task ObjShot_SpawnNewBulletSlowDownA1(obj, spdmod, fr, ngraphic){
	while(ObjMove_GetSpeed(obj)==0){yield;}
	let nspd = ObjMove_GetSpeed(obj)*spdmod;
	descent(i in 0..fr){
		ObjMove_SetSpeed(obj, nspd/fr*i);
		yield;
	}
	if(Obj_IsDeleted(obj)){return;}
	PlaySoundB1("se_kira02", 70);
	CreateObjShotA1(ObjMove_GetX(obj), ObjMove_GetY(obj), nspd/spdmod, ObjMove_GetAngle(obj), ngraphic, 12);
	Obj_Delete(obj);
}

task SparkTest(obj, length){
	let col = [64, 255, 224];

	loop{
		CreateSparkA1(ObjRender_GetX(obj), ObjRender_GetY(obj), rand(0, 360), 13, rand(100, 175), 9, round(rand(5, 6)), 3, 7, [96, 255, 255], 9, 0.6);
		loop(6){yield;}
	}
	
	
	
}

task CreateSparkA1(x, y, ang, angdev, size, sizedev, lines, animspd, animlength, rgb, delay, pri){
	let dist = 0;
	let dsize = size/lines;
	let countVertex = 1+lines;
	let obj = ObjPrim_Create(OBJ_PRIMITIVE_2D);
	ObjPrim_SetPrimitiveType(obj, PRIMITIVE_LINESTRIP);
	ObjPrim_SetVertexCount(obj, countVertex);
	ObjRender_SetAlpha(obj, 255);
	Obj_SetRenderPriority(obj, pri);
	ObjRender_SetColor(obj, rgb[0], rgb[1], rgb[2]);
	ObjPrim_SetTexture(obj, NULL);
		
	ascent(iVert in 0..countVertex){			
		let nang = ang + cos(rand(0, 360))*angdev;
		DoVertexProperties(iVert, x+dist*cos(nang), y+dist*sin(nang));	
		dist += dsize + sin(rand(0,360))*sizedev;
	}
	loop(delay+countVertex*animspd+animlength*2+1){yield;}
	Obj_Delete(obj);
	
	
	task DoVertexProperties(vert, x, y){
		ObjPrim_SetVertexPosition(obj, vert, x, y, 0);
		ObjPrim_SetVertexUVT(obj, vert, 0, 0);
		ObjPrim_SetVertexAlpha(obj, vert, 0);
		
		loop(vert*animspd){yield;}
		
		ascent(i in 0..animlength){
			let alph = 255/animlength*i;
			ObjPrim_SetVertexAlpha(obj, vert, alph);
			yield;
		}
		loop(delay){yield;}
		descent(i in 0..animlength){
			let alph = 255/animlength*i;
			ObjPrim_SetVertexAlpha(obj, vert, alph);
			yield;
		}
	}
}


task ObjShot_AddDeletionFrameA1(obj,time){
	ObjShot_SetAutoDelete(obj, false);
	loop(time){yield;}
	ObjShot_SetAutoDelete(obj, true);
}


//clean these up
task CreateShape(x, y, ang, sides, bullets, size){

	// let sides = 8; //number of edges
	// let bullets = 24; //number of bullets in each each
	// let size = 48; //how large each edge is
	ascent(i in 0..sides){
		let sangle = ang+360/sides*i; // angle of the edge
		let xinc = (size/bullets)*cos(sangle);
		let yinc = (size/bullets)*sin(sangle);
		ascent(b in 0..bullets){
			CreateObjShotA1(x, y, 0, sangle, 30, 10);
			x+=xinc;
			y+=yinc;
			yield;
		}
	}
}
task CreateTriangleWave{	
	let x = EnemyX;
	let y = EnemyY;
	let waves = 5; //lines of knives
	let bullet_start = 1; //number of starting knives
	let bullet_inc = 1; //number of knives increased per wave
	let angle = GetAngleToPlayer(Enemy); // starting angle
	let start_ang = 10; //how wide the knives are, with the starting angle being the center
	let ang_inc = 7; //how much wider the knives get per wave
	
	ascent(i in 0..waves){
		let bullets = bullet_start+bullet_inc*i;
		let ang_offset = (start_ang+ang_inc*i)/bullets;
		ascent(o in 0..bullets){
			let ang = angle + ang_offset*o - (ang_offset*(bullets-1))/2;
			CreateShotA1(x, y, 1+0.2*i, ang, 10, 10);
		}
	}
}

function ObjEnemy_GetID(name){
	let v = Obj_GetValueD(objScene, name, ID_INVALID);
	if(v==ID_INVALID){RaiseError("Boss ID was not found.");}
	return v;
}



function ObjMove_BasicWeightB1(id, x, y, a, b){
	if(!IsDoubleBattle){
		ObjMove_SetDestAtWeight(Enemy, rand(120, GetStgFrameWidth-120), rand(80, GetStgFrameHeight/2-75), 10, 3);
	}else{
		ObjMove_SetDestAtWeight(Enemy, rand(144, GetStgFrameWidth-144), rand(80, GetStgFrameHeight/2-75), 10, 3);
	}
}


function SetBossCollision(type){
	IsEnemyBounding = type;
}
function SetBossBulletCollision(type){
	IsEnemyBounded = type;
}

function SetBossInvisible(type){
	IsEnemyBounding = !type;
	IsEnemyBounded = !type;
}


function TeleportA1(obj, x, y, delay, tpdelay){
	descent(i in 0..tpdelay){
		ObjRender_SetScaleXYZ(obj, 1/tpdelay*i, 1, 1);
		if(!Hold(1)){break;}
	}
	SetBossInvisible(true);
	if(!Hold(floor(delay*0.2))){break;}
	ObjMove_SetPosition(obj, x, y);
	if(!Hold(ceil(delay*0.8))){break;}
	SetBossInvisible(false);
	ascent(i in 0..tpdelay){
		ObjRender_SetScaleXYZ(obj, 1/tpdelay*i, 1, 1);
		if(!Hold(1)){break;}
	}
}

task TeleportT1(obj, x, y, delay, tpdelay){
	TeleportA1(obj, x, y, delay, tpdelay);
}

function CreateBossObject(SBIimage, rec1, rec2, rec3, rec4){
	Obj_SetValue(Enemy, "Damage", 55);
	// if(GetScriptArgumentCount > 0){
		// return GetScriptArgument(0);
	// }
	let CBOboss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(CBOboss);
	ObjPrim_SetTexture(CBOboss, SBIimage); 
	ObjSprite2D_SetSourceRect(CBOboss, rec1, rec2, rec3, rec4); 
	ObjSprite2D_SetDestCenter(CBOboss);
	// ObjMove_SetPosition(CBOboss, rand(0, GetStgFrameWidth), -48);
	// ObjMove_SetDestAtWeight(CBOboss, GetStgFrameWidth/2, GetStgFrameHeight/3, 5, 6);
	
	
	SetUpDamagingVisualA1(CBOboss);
	Obj_SetValue(CBOboss, "Damage", 32+argument/2);
	return CBOboss;
}

function CreateEnemyObject(CEOlife, SBIimage, rec1, rec2, rec3, rec4){
	let CEOboss = ObjEnemy_Create(OBJ_ENEMY);
	ObjEnemy_Regist(CEOboss);
	ObjPrim_SetTexture(CEOboss, SBIimage); 
	ObjSprite2D_SetSourceRect(CEOboss, rec1, rec2, rec3, rec4); 
	ObjSprite2D_SetDestCenter(CEOboss);
	ObjEnemy_SetLife(CEOboss, CEOlife);
	return CEOboss;
}

function CreateFairyObject(CEOlife){
	let cfofairy = ObjEnemy_Create(OBJ_ENEMY);
	ObjEnemy_Regist(cfofairy);
	ObjPrim_SetTexture(cfofairy, img_fairy); 
	ObjEnemy_SetLife(cfofairy, CEOlife);
	return cfofairy;
}

task BossLifeSingleA1(EnemyObj){
	let path = img_lifebar;
	let countVertex = 24+14*quality;
	let objScene = ID_INVALID;
	
	let objLife = ObjPrim_Create(OBJ_PRIMITIVE_2D);
	ObjPrim_SetPrimitiveType(objLife, PRIMITIVE_TRIANGLESTRIP);
	ObjPrim_SetVertexCount(objLife, countVertex);
	ObjRender_SetBlendType(objLife, BLEND_ALPHA);
	Obj_SetRenderPriority(objLife, 0.69);
	ObjPrim_SetTexture(objLife, path);
	
	let objOutline = ObjPrim_Create(OBJ_PRIMITIVE_2D);
	ObjPrim_SetPrimitiveType(objOutline, PRIMITIVE_TRIANGLESTRIP);
	ObjPrim_SetVertexCount(objOutline, countVertex);
	ObjRender_SetBlendType(objOutline, BLEND_ALPHA);
	Obj_SetRenderPriority(objOutline, 0.68);
	ObjPrim_SetTexture(objOutline, path);
	
	ascent (iVert in 0..countVertex/2){
		let vertex = iVert * 2;
		ObjPrim_SetVertexUVT(objLife, vertex+0, 0, 0);
		ObjPrim_SetVertexUVT(objLife, vertex+1, 10, 32);	
		ObjPrim_SetVertexUVT(objOutline, vertex+0, 10, 0);
		ObjPrim_SetVertexUVT(objOutline, vertex+1, 19, 32);		
	}
	
	let mx = 0;
	let my = 0;
	let fade = 255;
	let fadec = 255;
	let maxRadius = 54;
	
	let lifeRateRender = 0;
	let outlineRender = 0;
	
	let lifeTotalMax = ObjEnemy_GetInfo(EnemyObj, INFO_LIFE);
	let lifeTotal = ObjEnemy_GetInfo(EnemyObj, INFO_LIFE);
	let lifeRate = min(lifeTotal / lifeTotalMax, lifeRateRender);
	
	
	
	ObjRender_SetScaleXYZ(objLife, -1, 1, 1);
	ObjRender_SetScaleXYZ(objOutline, -1, 1, 1);
	
	
	while(lifeTotal / lifeTotalMax>0){	
		
		mx = ObjRender_GetX(EnemyObj);
		my = ObjRender_GetY(EnemyObj);
		RefreshVertex(objLife);

		if(GetDistance(GetPlayerX,GetPlayerY,mx,my)<maxRadius*1.75){
			fadec = max(fadec-10, 85);
		}else{fadec = min(fadec+10, 255);}
		ObjRender_SetAlpha(objOutline, fadec);
		ObjRender_SetAlpha(objLife, fadec);
		
		if(GetCommonData("ForceLifebar", 0) != 0){
			outlineRender = 0;
			lifeRateRender = 0;
		}
		
		yield;
	}
	Obj_Delete(objOutline);
	Obj_Delete(objLife);

	task RefreshVertex(objid){	
		lifeTotal = ObjEnemy_GetInfo(EnemyObj, INFO_LIFE);
		lifeRate = min(lifeTotal / lifeTotalMax, lifeRateRender);
		
		ascent(iVert in 0..countVertex/2){
			let indexVert = iVert * 2;
			let angle = (360 / (countVertex/2 - 1) * iVert);
			angle = min(360*(outlineRender), angle);
			let x = (maxRadius)*cos(angle-90);
			let y = (maxRadius)*sin(angle-90);
			ObjPrim_SetVertexPosition(objOutline, indexVert + 0 , x, y, 0);
			x = (maxRadius*1.1)*cos(angle-90);
			y = (maxRadius*1.1)*sin(angle-90);
			ObjPrim_SetVertexPosition(objOutline, indexVert + 1 , x, y, 0);
			
			angle = min(360*(lifeRate), angle);
			x = (maxRadius)*cos(angle-90);
			y = (maxRadius)*sin(angle-90);
			ObjPrim_SetVertexPosition(objLife, indexVert + 0 , x, y, 0);			
			x = (maxRadius*1.1)*cos(angle-90);
			y = (maxRadius*1.1)*sin(angle-90);
			ObjPrim_SetVertexPosition(objLife, indexVert + 1 , x, y, 0);
		}
		ObjRender_SetPosition(objLife, mx, my, 0);
		ObjRender_SetPosition(objOutline, mx, my, 0);
		
		lifeRateRender = min(1, lifeRateRender+0.02);
		outlineRender = min(1, outlineRender+0.016);
		
	}
}


task ConcentrationF1(objid, r, g, b, delay){
	let locframe = 0;
	let cx = ObjRender_GetX(objid);
	let cy = ObjRender_GetY(objid);
	CreateCircleA1(objid, 136, -80/delay*2, 12, r, g, b);
	while(delay>0){
		if(Obj_IsDeleted(objid)){return;}
		cx = ObjRender_GetX(objid);
		cy = ObjRender_GetY(objid);
		if(locframe>2){
			ExplosionA3(cx, cy, cx+rand(64, 128)*cos(rand(0,360)), cy+rand(64, 128)*sin(rand(0,360)), rand(1, 3)); 
			locframe = 0;
		}
		locframe++;
		delay--;
		yield;
	}
	PlaySoundB1("se_tan01", 95);
	CreateCircleA1(objid, 0, 10, 1, r, g, b);
	loop((quality+3)*6){ExplosionA3(cx+rand(215, 160)*cos(rand(0,360)), cy+rand(215, 160)*sin(rand(0,360)), cx, cy, rand(2, 3.75));}
	
	task ExplosionA3(dx, dy, deX, deY, scale){
		// sloppier than sloppy
		let angX = rand(180, -180);
		let angY = rand(180, -180);
		let angZ = rand(180, -180);
		let spd = scale*1.5;
		let ang = atan2(dy - deY, dx - deX);
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		Obj_SetRenderPriority(obj, 0.60);
		ObjPrim_SetTexture(obj, img_effect);
		ObjSprite2D_SetSourceRect(obj, 32, 228, 64, 252);
		ObjSprite2D_SetDestRect(obj, -16, -12, 16, 12);
		ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
		ObjRender_SetPosition(obj, deX, deY, 0);
		let alpha = 195;
		let randX = rand(-500, 500);
		let randY = rand(-500, 500);
		let odist = GetDistance(deX,deY,dx,dy);
		while(!Obj_IsDeleted(obj)){
			let dist = GetDistance(deX,deY,dx,dy);
			scale = scale-0.05;
			alpha += -0.1;
			deX += spd*cos(ang);
			deY += spd*sin(ang);
			angX += randX/85;
			angY += randY/85;
			angZ += randX/135+randY/135;
			ObjRender_SetPosition(obj, deX, deY, 0);
			ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
			ObjRender_SetAlpha(obj, alpha*(dist/odist));
			ObjRender_SetScaleXYZ(obj, scale, scale, scale);
			if(scale<0||dist<spd){Obj_Delete(obj)}
			yield;
		}
		Obj_Delete(obj);
	}
}

task ConcentrationF2(objid){
	let locframe = 0;
	while(!EnemyDead){
		let x = ObjRender_GetX(objid);
		let y = ObjRender_GetY(objid);
		if(locframe>7-quality){loop(3){ExplosionA3(EnemyX, EnemyY, rand(1, 2.35));} locframe = 0;}
		locframe++;
		yield;
	}
	task ExplosionA3(dx, dy, deScale){
		// sloppier than sloppy
		let angX = rand(180, -180);
		let angY = rand(180, -180);
		let angZ = rand(180, -180);
		let spd = rand(1, 4);
		let deX = dx+rand(64, 160)*cos(angZ);
		let deY = dy+rand(64, 160)*sin(angZ);
		let ang = atan2(dy - deY, dx - deX);
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		Obj_SetRenderPriority(obj, 0.60);
		ObjPrim_SetTexture(obj, img_effect);
		ObjSprite2D_SetSourceRect(obj, 32, 228, 64, 252);
		ObjSprite2D_SetDestRect(obj, -16, -12, 16, 12);
		ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
		ObjRender_SetPosition(obj, deX, deY, 0);
		ObjRender_SetColor(obj, 128, 128, 255);
		let alpha = 195;
		let scale = deScale;
		let randX = rand(-500, 500);
		let randY = rand(-500, 500);
		while(!Obj_IsDeleted(obj)){
			let dist = GetDistance(deX,deY,dx,dy);
			scale = scale-0.05;
			alpha += -0.1;
			deX += spd*cos(ang);
			deY += spd*sin(ang);
			angX += randX/85;
			angY += randY/85;
			angZ += randX/135+randY/135;
			
			ObjRender_SetPosition(obj, deX, deY, 0);
			ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
			ObjRender_SetAlpha(obj, alpha);
			ObjRender_SetScaleXYZ(obj, scale, scale, scale);
			
			if(scale<0||dist<spd){Obj_Delete(obj)}
			yield;
		}
		Obj_Delete(obj);
	}
}

task ConcentrationF3(objid, r, g, b, delay){
	let locframe = 0;
	let cx = ObjRender_GetX(objid);
	let cy = ObjRender_GetY(objid);
	CreateCircleA1(objid, 136, -80/delay*2, 12, r, g, b);
	while(delay>0){
		if(Obj_IsDeleted(objid)){return;}
		cx = ObjRender_GetX(objid);
		cy = ObjRender_GetY(objid);
		if(locframe>2){
			ExplosionA3(cx, cy, cx+rand(64, 128)*cos(rand(0,360)), cy+rand(64, 128)*sin(rand(0,360)), rand(1, 3)); 
			locframe = 0;
		}
		locframe++;
		delay--;
		yield;
	}
	
	task ExplosionA3(dx, dy, deX, deY, scale){
		// sloppier than sloppy
		let angX = rand(180, -180);
		let angY = rand(180, -180);
		let angZ = rand(180, -180);
		let spd = scale*1.5;
		let ang = atan2(dy - deY, dx - deX);
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		Obj_SetRenderPriority(obj, 0.60);
		ObjPrim_SetTexture(obj, img_effect);
		ObjSprite2D_SetSourceRect(obj, 32, 228, 64, 252);
		ObjSprite2D_SetDestRect(obj, -16, -12, 16, 12);
		ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
		ObjRender_SetPosition(obj, deX, deY, 0);
		let alpha = 195;
		let randX = rand(-500, 500);
		let randY = rand(-500, 500);
		let odist = GetDistance(deX,deY,dx,dy);
		while(!Obj_IsDeleted(obj)){
			let dist = GetDistance(deX,deY,dx,dy);
			scale = scale-0.05;
			alpha += -0.1;
			deX += spd*cos(ang);
			deY += spd*sin(ang);
			angX += randX/85;
			angY += randY/85;
			angZ += randX/135+randY/135;
			ObjRender_SetPosition(obj, deX, deY, 0);
			ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
			ObjRender_SetAlpha(obj, alpha*(dist/odist));
			ObjRender_SetScaleXYZ(obj, scale, scale, scale);
			if(scale<0||dist<spd){Obj_Delete(obj)}
			yield;
		}
		Obj_Delete(obj);
	}
}


task PlaySound(name){
	NotifyEventAll(EV_USER+30, name~"^"~IntToString(90));
}

task PlaySoundA1(name){
	NotifyEventAll(EV_USER+30, name~"^"~IntToString(90));
}

task PlaySoundB1(name, vol){
	NotifyEventAll(EV_USER+30, name~"^"~IntToString(vol));
	/*
	return;
	let ID = -1;
	let GlobalSounds = GetCommonData("GlobalSoundData", [-1]);
	let GlobalSndStr = GetCommonData("GlobalSndStrData", [-1]);
	ascent(i in 0..length(GlobalSndStr)){
		if(GlobalSndStr[i]==name){ID = i; break;}
	}
	if(ID==-1){RaiseError("Error when attempting to play audio: "~name);}
	ObjSound_SetVolumeRate(GlobalSounds[ID], SE_VOL*(vol/100));
	ObjSound_Play(GlobalSounds[ID]);
	*/
}

task PlaySoundOoooooooo1(obj, del, name, vol){

	loop(del){yield;}
	if(Obj_IsDeleted(obj)){return;}

	//NotifyEvent(packageScript, EV_USER+30, name~"^"~IntToString(vol));
	NotifyEventAll( EV_USER+30, name~"^"~IntToString(vol));
}



task PlayEnemyHitSound(SoundHitEffectObjectID, hitsoundtype){
	SoundHitEffectObjectID = GetRealBoss;
	let bosshp = ObjEnemy_GetInfo(SoundHitEffectObjectID, INFO_LIFE);
	let origbosshp = ObjEnemy_GetInfo(SoundHitEffectObjectID, INFO_LIFE);
	
	while(EnemyDead == false && Obj_IsDeleted(SoundHitEffectObjectID) == false){
		if(bosshp != ObjEnemy_GetInfo(SoundHitEffectObjectID, INFO_LIFE) && hitsoundtype == 1){
			if(ObjEnemy_GetInfo(SoundHitEffectObjectID, INFO_LIFE) > origbosshp/12){PlaySoundO2(damage_00, 100);}
			if(ObjEnemy_GetInfo(SoundHitEffectObjectID, INFO_LIFE) < origbosshp/12){PlaySoundO2(damage_01, 100);}
			SetAreaCommonData("CirnoPlayer", "IncreaseIce", 0.6);
		}
		if(bosshp != ObjEnemy_GetInfo(SoundHitEffectObjectID, INFO_LIFE) && hitsoundtype == 2){PlaySoundO2(damage_00, 80);}
		if(bosshp != ObjEnemy_GetInfo(SoundHitEffectObjectID, INFO_LIFE) && hitsoundtype == 3){PlaySoundO2(se_nodamage, 80);}
		
		bosshp = ObjEnemy_GetInfo(SoundHitEffectObjectID, INFO_LIFE);
		yield;
	}
}

task SetInvincibility(enemyobject, delay, shotfactor, bombfactor){
	if(GetRealBossA2(enemyobject) == enemyobject){
		ObjEnemy_SetDamageRate(enemyobject, 0, 0);	
		loop(delay){yield;}
		ObjEnemy_SetDamageRate(enemyobject, shotfactor, bombfactor/max(1, argument/20-2));	
	}else{
		ObjEnemy_SetDamageRate(GetRealBoss, 0, 0);	
		ObjEnemy_SetDamageRate(enemyobject, 0, 0);	
		
		if(IsPairingActive && GetBossRank == 1){
			loop(delay){yield;}
			ObjEnemy_SetDamageRate(enemyobject, 0.1, 0.1);	
			return;
		}
		loop(delay){yield;}
		ObjEnemy_SetDamageRate(GetRealBoss, shotfactor, bombfactor/max(1, argument/20-2));
		ObjEnemy_SetDamageRate(enemyobject, 0.1, 0.1);	
	}
}


task StarOnBossSingleA1(Enemy){ 
	let objID = ObjPrim_Create(OBJ_SPRITE_2D);
	let objxpos = -400;
	let objypos = -400;
	let obj_angle = 0;
	let osize = 0;
	let oshift = 0;
	let mspd = 0.15;

	ObjRender_SetBlendType(objID, BLEND_ALPHA);
	Obj_SetRenderPriority(objID, 0.3);
	ObjPrim_SetTexture(objID, img_effect);
	ObjSprite2D_SetSourceRect(objID, 128, 80, 256, 208);
	ObjSprite2D_SetDestRect(objID, -64, -64, 64, 64);
	ObjRender_SetAlpha(objID, 145);
	ObjRender_SetColor(objID, 255,200,200);
	
	ascent(i in 0..60){
		obj_angle = max(obj_angle-6+min(i/9.75, 6), -180);
		osize = min(osize+0.075-i/1850, 1.7);
		UpdateStar;
		yield;
	}
	loop(5){yield;}
	while(!Obj_IsDeleted(Enemy)){
		mspd = min(mspd+0.03, 1);
		obj_angle-=5*mspd;
		oshift+=2.631*mspd;
		UpdateStar;
		yield;
	}
	Obj_Delete(objID);
	sub UpdateStar{
		objxpos = ObjMove_GetX(Enemy);
		objypos = ObjMove_GetY(Enemy);		
		ObjRender_SetPosition(objID, objxpos, objypos, 0);
		ObjRender_SetScaleXYZ(objID, osize+0.25*sin(oshift), osize+0.25*sin(oshift), 1);
		ObjRender_SetAngleZ(objID, obj_angle);
		//ObjRender_SetAngleXYZ(objID, osize+30*cos(oshift+180), osize+30*sin(oshift+180), obj_angle); heh
	}
}

task AuraOnBossSingle(objid, r, g, b){	
	loop(4){yield;}
	if(quality==0){return;}
	let shift = [0, 120, 240];
	let color = [0, 0, 0];
	if(b != 0){color = [r,g,b];}
	let fe = 0;
	while(!Obj_IsDeleted(objid)){
		if(b==0){
			ascent(i in 0..3){
				shift[i] = shift[i]+2;
				color[i] = sin(shift[i])*128+127;
			}
		}
		if(fe>=9){
			EffectAu1(ObjRender_GetX(objid), ObjRender_GetY(objid), 0);
			EffectAu1(ObjRender_GetX(objid), ObjRender_GetY(objid), 1);
			fe = 0;
		}
		fe++;
		yield;
	}	
	task EffectAu1(x, y, type){
		let oy = y;
		let alpha = rand(155, 205);
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		Obj_SetRenderPriority(obj, 0.31);
		ObjPrim_SetTexture(obj, img_effect);
		ObjSprite2D_SetSourceRect(obj, (type)*48, 144, (type+1)*48, 192);
		ObjSprite2D_SetDestCenter(obj);
		ObjRender_SetScaleXYZ(obj, rand(1, 1.65), rand(1, 1.95), 1);
		ObjRender_SetAngleZ(obj, rand(0, 360));
		let rang = 90;
		if(type==0){
			ObjRender_SetAngleZ(obj, rand(-20, 20));
		}else{rang = rand(0,360);}
		ObjRender_SetColor(obj, color[0], color[1], color[2]);
		ObjRender_SetPosition(obj, x, y, 0);
		ObjRender_SetAlpha(obj, alpha);
		
		let xm = cos(rang);
		let ym = sin(rang);
		
		while(alpha>0){
			x = x-((1-type)*2.15+1)*xm;
			y = y-((1-type)*2.15+1)*ym;
			alpha = max(alpha-8, 0);
			ObjRender_SetPosition(obj, x, y, 0);
			ObjRender_SetAlpha(obj, alpha);
			yield;
		}
		Obj_Delete(obj);
	}
}

task NameOnBossSingle(objid, text){
	if(quality==0){return}
	let objText = ObjText_Create;
	ObjText_SetFontSize(objText, 11);
	ObjText_SetFontColorTop(objText, 120, 220, 154);
	ObjText_SetFontColorBottom(objText, 120, 220, 154);
	
	ObjText_SetHorizontalAlignment(objText, ALIGNMENT_LEFT);
	ObjText_SetMaxWidth(objText, 999);
	Obj_SetRenderPriority(objText, 0.79);
	ObjRender_SetX(objText, 1);
	ObjRender_SetY(objText, 1);
	ObjText_SetText(objText, text);
	if(quality==1){
		ObjRender_SetY(objText, 14);
	}
	
	
	while(!Obj_IsDeleted(objid)){
		yield;
	}
	Obj_Delete(objText);
}

task ExplosionSA1(deX, deY, angX, angY, angZ){
	
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA );
	Obj_SetRenderPriority(obj, 0.50);
	ObjPrim_SetTexture(obj, img_effect);
	ObjSprite2D_SetSourceRect(obj, 129, 17, 191, 79);
	ObjSprite2D_SetDestRect(obj, -32, -32, 32, 32);
	ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
	ObjRender_SetPosition(obj, deX, deY, 0);
	
	let alpha = 255;
	let scale = 0;
	let expo = 0.4;
	let RandZ = rand(-170,170);
	while(Obj_IsDeleted(obj)==false){
	
		if(alpha>100){scale += expo;}else{scale -= expo;}
		alpha -= 5;
		if(expo>0){expo = expo^1.07;}
		
		ObjRender_SetAlpha(obj, alpha);
		ObjRender_SetScaleXYZ(obj, scale*1.1, scale*1.1, 1);
		
		if(alpha<0){Obj_Delete(obj)}
		yield;
	}
	Obj_Delete(obj);
}

task ExplosionSA2(deX, deY, angX, angY, angZ, deScale){
	
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, 0.60);
	ObjPrim_SetTexture(obj, img_effect);
	ObjSprite2D_SetSourceRect(obj, 32, 228, 64, 252);
	ObjSprite2D_SetDestRect(obj, -16, -12, 16, 12);
	ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
	ObjRender_SetPosition(obj, deX, deY, 0);
	
	let alpha = 125;
	let scale = deScale;
	let randX = rand(-500, 500);
	let randY = rand(-500, 500);
	let RandZ = rand(-170,170);
	//atan2(randY - deX, randX - deY);
	while(Obj_IsDeleted(obj)==false){
		scale += -0.05;
		alpha += -0.1;
		deX += randX/100;
		deY += randY/100;
		angX += randX/85;
		angY += randY/85;
		angZ += randX/135+randY/135;
		
		ObjRender_SetPosition(obj, deX, deY, 0);
		ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
		ObjRender_SetAlpha(obj, alpha);
		ObjRender_SetScaleXYZ(obj, scale, scale, scale);
		
		if(scale<0.01){Obj_Delete(obj)}
		yield;
	}
	Obj_Delete(obj);
}

task ExplosionSB1(deX, deY, presetColor, angX, angY, angZ){
	
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA );
	Obj_SetRenderPriority(obj, 0.50);
	ObjPrim_SetTexture(obj, img_effect);
	if(presetColor=="red"){ObjSprite2D_SetSourceRect(obj, 129, 17, 191, 79);}
	if(presetColor=="blue"){ObjSprite2D_SetSourceRect(obj, 192, 17, 259, 79);}
	if(presetColor=="yellow"){ObjSprite2D_SetSourceRect(obj, 0, 81, 65, 145);}
	if(presetColor=="green"){ObjSprite2D_SetSourceRect(obj, 64, 81, 129, 145);}
	ObjSprite2D_SetDestRect(obj, -32, -32, 32, 32);
	ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
	ObjRender_SetPosition(obj, deX, deY, 0);
	
	let alpha = 155;
	let scale = 0;
	let expo = 0.4;
	let RandZ = rand(-170,170);
	while(Obj_IsDeleted(obj)==false){
	
		scale += expo/2;
		alpha -= 6.2;
		if(expo>0){expo = expo^1.07;}
		
		ObjRender_SetAlpha(obj, alpha);
		ObjRender_SetScaleXYZ(obj, scale*1.1, scale*1.1, 1);
		
		if(alpha<0){Obj_Delete(obj)}
		yield;
	}
	Obj_Delete(obj);
}

task ExplosionSB2(deX, deY, colorR, colorG, colorB, deScale){
	if(TotalEffect>TotalEffectMax){return;}
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	let angX = rand(-360, 360);
	let angY = rand(-360, 360);
	let angZ = rand(-360, 360);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, 0.60);
	ObjPrim_SetTexture(obj, img_effect);
	ObjSprite2D_SetSourceRect(obj, 0, 228, 33, 251);
	ObjSprite2D_SetDestRect(obj, -16, -12, 16, 12);
	ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
	ObjRender_SetPosition(obj, deX, deY, 0);
	ObjRender_SetColor(obj, colorR, colorG, colorB);
	
	let alpha = 105;
	let scale = deScale;
	let randX = rand(-500, 500);
	let randY = rand(-500, 500);
	let RandZ = rand(-170,170);
	//atan2(randY - deX, randX - deY);
	TotalEffect++;
	while(Obj_IsDeleted(obj)==false){
		scale += -0.05;
		alpha += -0.1;
		deX += randX/100;
		deY += randY/100;
		angX += randX/85;
		angY += randY/85;
		angZ += randX/135+randY/135;
		
		ObjRender_SetPosition(obj, deX, deY, 0);
		ObjRender_SetAngleXYZ(obj, angX, angY, angZ);
		ObjRender_SetAlpha(obj, alpha);
		ObjRender_SetScaleXYZ(obj, scale, scale, scale);
		
		if(scale<0.01){Obj_Delete(obj)}
		yield;
	}
	TotalEffect--;
	Obj_Delete(obj);
}

task DeathExplosionA1(x, y){
	DeathExplosionAC1(x, y, 0);
	DeathExplosionAC1(x, y, 26);
	DeathExplosionAC1(x+32, y, 4);
	DeathExplosionAC1(x-32, y, 4);
	DeathExplosionAC1(x, y+32, 4);
	DeathExplosionAC1(x, y-32, 4);
}

task DeathExplosionAC1(x, y, delay){
	loop(delay){yield;}
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_INV_DESTRGB);
	Obj_SetRenderPriority(obj, 0.65);
	ObjPrim_SetTexture(obj, img_Circle);
	ObjRender_SetPosition(obj, x, y, 0);
	ObjSprite2D_SetSourceRect(obj, 0, 0, 1023, 1023);
	ObjSprite2D_SetDestCenter(obj);
	let scale = 1;
	let expo = 1;
	let exp2 = 0;
	while(scale<2048){
		scale += expo;
		expo+=1.45+exp2;
		exp2+=0.085;
		let ns = scale/1024;
		ObjRender_SetScaleXYZ(obj, ns, ns, 1);
		yield;
	}
	loop(26-delay){yield;}
	Obj_Delete(obj);
}

task CreateWarningLaserA1(x, y, angle, spd, len, delay, tdelay, bcol){
	loop(tdelay){yield;}
	//1009 - laser aqua
	let hdelay = delay/2;
	if(delay/2<=16){RaiseError("Delay needs to be higher than 32... it is " ~ IntToString(delay));}
	let l = CreateStraightLaserA1(x, y, angle, len, 48, 0, 517, delay); //laser white
	ObjStLaser_SetSource(l, false);
	ascent(i in 0..15){
		let col = 255/15*i;
		ObjRender_SetColor(l, col, col, col);
		yield;
	}
	let ll = ID_INVALID;
	if(bcol!=-1){ll = CreateLooseLaserA1(x, y, spd, angle, 256, 14, bcol, 0);}
	ObjShot_SetSpellResist(ll, true);
	ObjRender_SetColor(ll, 128, 128, 128);
	ObjShot_SetIntersectionEnable(ll, false);
	ObjShot_SetAutoDelete(ll, false);
	loop(delay-30){yield;}
	descent(i in 0..15){
		let col = 255/15*i;
		ObjRender_SetColor(l, col, col, col);
		ObjRender_SetColor(ll, col/2, col/2, col/2);
		yield;
	}
	Obj_Delete(l);
	Obj_Delete(ll);
}

function CreateWarningSpiritA1(x1, y1, x2, y2, delay){
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ADD_ARGB);
	Obj_SetRenderPriority(obj, 0.5);
	ObjPrim_SetTexture(obj, img_effect);
	ObjSprite2D_SetSourceRect(obj, 65, 17, 128, 80);
	ObjSprite2D_SetDestRect(obj, -32, -32, 32, 32);
	ObjRender_SetAlpha(obj, 240);
	
	let frame = 0;
	let scl = 0;
	
	let ispd = rand(2, 6);
	let sang = rand(0,360);
	let sspd = rand(4,7);
	let smod = round(rand(0, 1));
	if(smod == 0){smod = -1;}
	
	let ang = rand(0, 360);
	let spd = 3;
	
	let mdel = delay*0.56;
	let del = round(delay*0.22);
	
	
	descent(i in 0..del){
		spd = ispd*i/del;
		scl = min(1, (1-1*i/del)*5);
		RenderProperties;
	}
	ang = AngleToLocation(x1, y1, x2, y2);
	let dist = GetDistance(x1, y1, x2, y2)-2;
	
	let remaining = delay - frame;
	while(dist > 2 && !EnemyDead){
		dist = GetDistance(x1, y1, x2, y2)-2;
		spd = min(spd+0.12, dist/mdel+2);
		RenderProperties;
	}
	if(!EnemyDead){
		x1 = x2;
		y1 = y2;
		spd = 0;
	}
	//while(frame < delay-del){RenderProperties;}
	ascent(i in 0..del){
		scl = 1-1*i/del;
		RenderProperties;
	}
	
	Obj_Delete(obj);
	
	sub RenderProperties{
		x1+=spd*cos(ang);
		y1+=spd*sin(ang);
		ObjRender_SetPosition(obj, x1, y1, 0);
		ObjRender_SetAngleZ(obj, sang);
		ObjRender_SetScaleXYZ(obj, scl, scl, 1);
		sang+=sspd*smod*(1+spd*0.4);
		yield;
		frame+=1;
	}
}


task CreateWarningLaserAttachedA1(obj1, obj2, time){
	let x1 = ObjRender_GetX(obj1);
	let y1 = ObjRender_GetY(obj1);
	let x2 = ObjRender_GetX(obj2);
	let y2 = ObjRender_GetY(obj2);
	
	let angle = AngleToLocation(x1,y1,x2,y2);
	let len = GetDistance(x1,y1,x2,y2);
	
	let l = CreateStraightLaserA1(x1, y1, angle, len, 64, 0, 1002, time); //laser white
	ObjStLaser_SetSource(l, false);
	
	ascent(i in 0..10){
		let col = 255/10*i;
		ObjRender_SetColor(l, col, col, col);
		UpdateProperties;
	}
	ascent(i in 0..time-20){
		if(obj1==ID_INVALID || obj2==ID_INVALID){break;}
		UpdateProperties;
	}
	descent(i in 0..10){
		let col = 255/10*i;
		ObjRender_SetColor(l, col, col, col);
		UpdateProperties;
	}
	Obj_Delete(l);
	
	sub UpdateProperties{
		if(obj1!=ID_INVALID){
			x1 = ObjRender_GetX(obj1);
			y1 = ObjRender_GetY(obj1);
		}
		if(obj2!=ID_INVALID){
			x2 = ObjRender_GetX(obj2);
			y2 = ObjRender_GetY(obj2);
		}
		angle = AngleToLocation(x1,y1,x2,y2);
		len = GetDistance(x1,y1,x2,y2);
		ObjLaser_SetLength(l, len);
		ObjStLaser_SetAngle(l, angle);
		yield;
	}
}


task CreateCircleA1(objid, siz, sinc, destsiz, r, g, b){
	let alpha = 255;
	let countVertex = round(destsiz*0.25);
	
	let circ = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjPrim_SetPrimitiveType(circ, PRIMITIVE_TRIANGLEFAN);
	ObjPrim_SetTexture(circ, NULL);
	Obj_SetRenderPriority(circ, 0.60);
	ObjPrim_SetVertexCount(circ, countVertex);
	ObjRender_SetBlendType(circ, BLEND_ALPHA);
	
	
	ObjPrim_SetVertexUVT(circ, 0, 0, 0);	
	ObjPrim_SetVertexPosition(circ, 0, 0, 0, 0);
	ObjPrim_SetVertexColor(circ, 0, 255, 255, 255);
	ObjPrim_SetVertexAlpha(circ, 0, 0);
	let x = ObjRender_GetX(objid);
	let y = ObjRender_GetY(objid);
	ObjRender_SetPosition(circ, x, y, 0);
	
	ascent(iVert in 1..countVertex){
		let angle = (360 / (countVertex - 2) * iVert);
		ObjPrim_SetVertexUVT(circ, iVert, 0, 0);	
		let x = siz*cos(angle);
		let y = siz*sin(angle);
		ObjPrim_SetVertexPosition(circ, iVert , x, y, 0);
		ObjPrim_SetVertexColor(circ, iVert, r, g, b);
		ObjPrim_SetVertexAlpha(circ, iVert, alpha);
	}
	while(alpha>0){
		if(!Obj_IsDeleted(objid)&&objid!=ID_INVALID){
			x = ObjRender_GetX(objid);
			y = ObjRender_GetY(objid);
		}
		ObjRender_SetPosition(circ, x, y, 0);
		siz += sinc/TimeSpeed;
		alpha -= 8;
		ascent(iVert in 1..countVertex){
			let angle = (360 / (countVertex - 2) * iVert);
			ObjPrim_SetVertexPosition(circ, iVert , (siz+8)*cos(angle), (siz+8)*sin(angle), 0);
			ObjPrim_SetVertexAlpha(circ, iVert, alpha);
		}
		yield;
	}
	Obj_Delete(circ);
}

task CreateCircleB1(x, y, siz, alphinc, circtime, r, g, b){
	let alpha = 0;
	let countVertex = 50;
	
	let circ = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjPrim_SetPrimitiveType(circ, PRIMITIVE_TRIANGLEFAN);
	ObjPrim_SetTexture(circ, NULL);
	Obj_SetRenderPriority(circ, 0.60);
	ObjPrim_SetVertexCount(circ, countVertex);
	ObjRender_SetBlendType(circ, BLEND_ALPHA);
	
	
	ObjPrim_SetVertexUVT(circ, 0, 0, 0);	
	ObjPrim_SetVertexPosition(circ, 0, 0, 0, 0);
	ObjPrim_SetVertexColor(circ, 0, 255, 255, 255);
	ObjPrim_SetVertexAlpha(circ, 0, 0);
	ObjRender_SetPosition(circ, x, y, 0);
	
	ascent(iVert in 1..countVertex){
		let angle = (360 / (countVertex - 2) * iVert);
		ObjPrim_SetVertexUVT(circ, iVert, 0, 0);	
		let x = siz*cos(angle);
		let y = siz*sin(angle);
		ObjPrim_SetVertexPosition(circ, iVert , x, y, 0);
		ObjPrim_SetVertexColor(circ, iVert, r, g, b);
		ObjPrim_SetVertexAlpha(circ, iVert, alpha);
	}
	ascent(i in 0..circtime){
		alpha = min(alpha+alphinc, 255);
		ascent(iVert in 1..countVertex){
			let angle = (360 / (countVertex - 2) * iVert);
			ObjPrim_SetVertexPosition(circ, iVert , (siz+8)*cos(angle), (siz+8)*sin(angle), 0);
			ObjPrim_SetVertexAlpha(circ, iVert, alpha);
		}
		yield;
	}
	while(alpha>0){
		alpha -= 7;
		ascent(iVert in 1..countVertex){
			let angle = (360 / (countVertex - 2) * iVert);
			ObjPrim_SetVertexPosition(circ, iVert , (siz+8)*cos(angle), (siz+8)*sin(angle), 0);
			ObjPrim_SetVertexAlpha(circ, iVert, alpha);
		}
		yield;
	}
	Obj_Delete(circ);
}


task SpawnLunacyA1(x, y){
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	let countVertex = 128;
	let rCoVert = countVertex/2;
	let iRad = 0;
	let oRad = 0;
	let rAng = 0;
	
	
	ObjPrim_SetPrimitiveType(obj, PRIMITIVE_TRIANGLESTRIP);
	ObjPrim_SetVertexCount(obj, countVertex);
	ObjRender_SetAlpha(obj, 255);
	Obj_SetRenderPriority(obj, 0.29);
	ObjPrim_SetTexture(obj, GetCurrentScriptDirectory~"test.png");
	ObjRender_SetPosition(obj, x, y, 0);	
	
	ascent(i in 0..rCoVert){
		let rx = 512/(rCoVert - 1)*i;
		let iVert = i * 2;
		ObjPrim_SetVertexUVT(obj, iVert, 512, rx);
		ObjPrim_SetVertexUVT(obj, iVert+1, 0, rx);
	}
	ascent(i in 0..300){
		PerformRenderProp;
		ObjRender_SetAlpha(obj, 300-i);
		iRad+=max(0, i/150-0.2);
		oRad+=1.2;
		rAng+=0.8-0.6/300*i;
		yield;
	}
	Obj_Delete(obj);
	
	sub PerformRenderProp{
		ObjRender_SetAngleZ(obj, rAng);
		ascent(i in 0..rCoVert){
			let ang = (360 / (rCoVert - 1) * i);
			let iVert = i * 2;
			let xm = cos(ang);
			let ym = sin(ang);
			ObjPrim_SetVertexPosition(obj, iVert, iRad*xm, iRad*ym, 0);
			ObjPrim_SetVertexPosition(obj, iVert+1, oRad*xm, oRad*ym, 0);
		}
	}
}


task ClearBullets(x, y, type, Tsize, Tspd, Tmaxrad, delay){
	let stopclear = true;
	loop(delay){yield;}
	while(stopclear==true){
		DeleteShotInCircle(TYPE_ALL,type,x,y,Tsize);
		Tsize += Tspd;
		if(Tsize>=Tmaxrad){
			stopclear = false;
		}
		yield;
	}
}



task CutinM1(Type, SpellName, Images, Colors, Score){
	if(GetEnemyBossSceneObjectID!=ID_INVALID){
		let boss = GetEnemyBossObjectID[0];
		Obj_SetValue(boss, "SpellcardType", Type);
		Obj_SetValue(boss, "SpellcardName", SpellName);
		Obj_SetValue(boss, "SpellcardImages", Images);
		Obj_SetValue(boss, "SpellcardColors", Colors);
		Obj_SetValue(boss, "SpellcardScore", Score*argument/32);
	}else{RaiseError("No boss was present.");}
}


task ObjCutin_SetSpellcardM4(SpellName, score, type, image, R, G, B){
	let r = IntToString(R);
	let g = IntToString(G);
	let b = IntToString(B);
	let boss = GetEnemyBossObjectID[0];
	let spells = Obj_GetValueD(boss, "gcut_Spellcards", []);
	spells = spells~[[SpellName, r, g, b, type, image]];
	Obj_SetValue(boss, "gcut_Spellcards", spells);
	Obj_SetValue(boss, "gcut_SpellcardScore", score);
}

task ObjCutin_SetSpellcardLayersM4(image){
	let boss = GetEnemyBossObjectID[0];
	Obj_SetValue(boss, "gcut_SpellImageLayer", image);
}

task ObjCutin_SetToFireOnlyImageA1(index){
	let boss = GetEnemyBossObjectID[0];
	Obj_SetValue(boss, "gcut_SpellImageFire", false);
}

task ObjCutin_SetSpellcardLayersMultiA1(image, index){
//currently only for aocf, should expand to allstar/etc later though
	let boss = GetEnemyBossObjectID[0];
	let nimg = [image]~Obj_GetValueD(boss, "gcut_SpellImageLayer"~IntToString(index), []);
	Obj_SetValue(boss, "gcut_SpellImageLayer"~IntToString(index), nimg);
}

task ObjCutin_AddUVTOffsetA1(xval, yval){
	let boss = GetEnemyBossObjectID[0];
	let uvtoffs = Obj_GetValueD(boss, "gcut_SpellUVTOffsets", []);
	Obj_SetValue(boss, "gcut_SpellUVTOffsets", uvtoffs~[[xval, yval]]);
}

task ObjCutin_ChangeEffectColorModA1(val){
	let boss = GetEnemyBossObjectID[0];
	Obj_SetValue(boss, "gcut_SpellEffectColorModifier", val);
}

task ObjCutin_AddAdditionalBossImageM4(image, r, g, b){
	let boss = GetEnemyBossObjectID[0];
	
	let nimg = [image]~Obj_GetValueD(boss, "gcut_SpellImageLayer", []);
	Obj_SetValue(boss, "gcut_SpellImageLayer", image);
	
	let nrgb = [[r, g, b]]~Obj_GetValueD(boss, "gcut_SpellColorLayer", [[]]);
	Obj_SetValue(boss, "gcut_SpellColorLayer", nrgb);
}





task ObjCutin_SetSpellcardM3(SpellName, image, cuttype, Score, R, G, B){
	ObjCutin_SetSpellcardM4(SpellName, Score, cuttype, image, R, G, B);
	
	return;
	let r = IntToString(R);
	let g = IntToString(G);
	let b = IntToString(B);
	let boss = GetEnemyBossObjectID[0];
	let spells = Obj_GetValueD(boss, "Spellcards", []);
	spells = spells~[[SpellName, r, g, b, cuttype, image]];
	Obj_SetValue(boss, "Spellcards", spells);
	Obj_SetValue(boss, "SpellcardScore", Score*max(1, argument/48));
}

task ObjCutin_SetSpellcardLayersM3(SpellNum, image){
	let boss = GetEnemyBossObjectID[0];
	Obj_SetValue(boss, "SpellImageLayer"~IntToString(SpellNum), image);
}


task ObjCutin_SetSpellcardLayersS3(SpellNum, image){
	let boss = GetEnemyBossObjectID[0];
	Obj_SetValue(boss, "SpellImageLayer"~IntToString(SpellNum), image);
}




function GetSpellcardName(NameArr){
	let diffval = [12, 36, 48, 72, 96, 120];
	let closest = [2, 999]; //[Array from diffval, distance]
	
	ascent(i in 0..length(diffval)){
		if(closest[1]>absolute(diffval[i]-argument)){
			closest[0] = i;
			closest[1] = absolute(diffval[i]-argument);
		}
	}
	return NameArr[max(0, min(5, closest[0]))];
}

function GetDifficultyVariableA1(NameArr){
	// pre set of 5 primary difficulties
	let diffval = [12, 36, 48, 72, 96, 120];
	let closest = [2, 999]; //[Array from diffval, distance]
	
	ascent(i in 0..length(diffval)){
		if(closest[1]>absolute(diffval[i]-argument)){
			closest[0] = i;
			closest[1] = absolute(diffval[i]-argument);
		}
	}
	return NameArr[max(0, min(5, closest[0]))];
}
function GetDifficultyVariableB1(NameArr){
	// arbitrary amount of 'difficulties'
	let num = length(NameArr);
	let diffval = [];
	ascent(i in 0..num){
		diffval = diffval ~ [120/num+120/num*i];
	}
	let closest = [0, 999]; //[Array from diffval, distance]
	
	ascent(i in 0..length(diffval)){
		if(closest[1]>absolute(diffval[i]-argument)){
			closest[0] = i;
			closest[1] = absolute(diffval[i]-argument);
		}
	}
	return NameArr[closest[0]];
}

function GetRandomValueFromArrayA1(NameArr){
	return NameArr[floor(rand(0, length(NameArr)))];
}

task ScreenShakeA1(shaketime, intensity){
	while(shaketime>0){
		Set2DCameraFocusX(GetStgFrameWidth/2 + rand(-intensity, intensity));
		Set2DCameraFocusY(GetStgFrameHeight/2 + rand(-intensity, intensity));
		shaketime--;
		yield;
	}
	Reset2DCamera;
	yield;
}
task ScreenShakeA2(shaketime, intensity){
	let ramp = 0;
	let fr = 0;
	while(shaketime>0){
		if(fr>=1){
			ramp = min(ramp+0.75, intensity);
			Set2DCameraFocusX(GetStgFrameWidth/2 + rand(-ramp, ramp));
			Set2DCameraFocusY(GetStgFrameHeight/2 + rand(-ramp, ramp));
			shaketime--;
		}else{
			
		}
		if(!IsTimeStopped){fr+=1/TimeSpeed;}
		yield;
	}
	Reset2DCamera;
	yield;
}

task ScreenShakeB2(length, startintensity, declength){
	let ramp = startintensity;
	ascent(i in 0..length){
		Set2DCameraFocusX(GetStgFrameWidth/2 + rand(-ramp, ramp));
		Set2DCameraFocusY(GetStgFrameHeight/2 + rand(-ramp, ramp));
		yield;
	}
	descent(i in 0..declength){
		ramp = startintensity/declength*i;
		Set2DCameraFocusX(GetStgFrameWidth/2 + rand(-ramp, ramp));
		Set2DCameraFocusY(GetStgFrameHeight/2 + rand(-ramp, ramp));
		yield;
	}
	Reset2DCamera;
	yield;
}

task ScreenShakeB1(shaketime, percent, inten){
	let x = Get2DCameraX;
	let y = Get2DCameraY;
	descent(i in 0..shaketime){
		let intensity = inten*(1-percent) + inten*percent/shaketime*i;
		Set2DCameraFocusX(GetStgFrameWidth/2 + rand(-intensity, intensity));
		Set2DCameraFocusY(GetStgFrameHeight/2 + rand(-intensity, intensity));
		if(EnemyDead){break;}
		yield;
	}
	Set2DCameraFocusX(GetStgFrameWidth/2);
	Set2DCameraFocusY(GetStgFrameHeight/2);
	yield;
}


task ScreenFlash(objid, decay, alpha){
	let menuscreen = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjPrim_SetTexture(menuscreen, img_Blank);
	ObjRender_SetBlendType(menuscreen, BLEND_ALPHA);
	Obj_SetRenderPriorityI(menuscreen, 69);
	ObjRender_SetAlpha(menuscreen, alpha);
	ObjSprite2D_SetSourceRect(menuscreen, 0, 0, 3, 3);
	ObjSprite2D_SetDestRect(menuscreen, -124, -124, 524, 524);
	
	while(alpha>0 && !Obj_IsDeleted(objid)){
		alpha+=decay;
		ObjRender_SetAlpha(menuscreen, alpha);
		yield;
	}
	
	Obj_Delete(menuscreen);
	
}

 // snow did this
task ScreenDistort(EnemyObject, AI, length){
	let renderTexture = GetReservedRenderTargetName(0);

	SetInvalidRenderPriorityA1(20, 79);

	let objCurentFrame = ObjPrim_Create(OBJ_SPRITE_2D);
	Obj_SetRenderPriorityI(objCurentFrame, 80);

	if(length == -1){while(ObjEnemy_GetInfo(EnemyObject, INFO_LIFE) > 0){PerformActions;yield;}}	
	if(length != -1){while(length>0){length--;PerformActions;yield;}}
	
	Obj_Delete(objCurentFrame);
	ClearInvalidRenderPriority;
	
	task PerformActions{
		let currentFrameTexture = renderTexture;
		RenderToTextureA1(currentFrameTexture, 20, 79, true);
		ObjPrim_SetTexture(objCurentFrame, currentFrameTexture);
		ObjSprite2D_SetSourceRect(objCurentFrame, 32, 16, 416, 464);
		ObjSprite2D_SetDestRect(objCurentFrame, rand(32, 36+AI), rand(16, 36+AI), rand(416-AI, 416), rand(464-AI, 464));
	}
}


task ScreenSplitA1(obj, col, wid){
	let renderTexture = GetReservedRenderTargetName(1);

	let frameskip = 0;
	SetInvalidRenderPriorityA1(20, 74);
	let currentFrameTexture = renderTexture;
	
	let mx = (GetStgFrameWidth)/wid;
	let my = (GetStgFrameHeight)/col;
	
	let AvailableSpots = [];

	ascent(w in 0..wid){
		ascent(l in 0..col){
			AvailableSpots = AvailableSpots ~ [[w*mx+mx/2+32, l*my+my/2+16, 1]];
		}
	}
	
	ascent(w in 0..wid){
		ascent(l in 0..col){
			CreateSquare(w*mx+mx/2+32, l*my+my/2+16, mx, my);
		}
	}
	
	
	while(!Obj_IsDeleted(obj)){
		if(frameskip>=0){
			PerformActions;
			frameskip = 0;
		}
		frameskip++;
		yield;
	}
	
	ClearInvalidRenderPriority;
	
	sub PerformActions{
		currentFrameTexture = renderTexture;
		RenderToTextureA1(currentFrameTexture, 20, 74, true);
	}
	
	
	task CreateSquare(dx, dy, ls, ws){
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetPosition(obj, GetStgFrameWidth/2, GetStgFrameHeight/2, 0);
		Obj_SetRenderPriorityI(obj, 75);
		
		
		let rx = dx;
		let ry = dy;
		let np = [dx, dy, 0];
			ObjRender_SetPosition(obj, rx-32, ry-16, 0);
		
		while(np[2]==0 && (dx != mx || dy != my)){
			let v = floor(rand(0, length(AvailableSpots)));
			let npspot = AvailableSpots[v];
			if(npspot[2] == 1){
				np = npspot;
				npspot[2] = 0;
				AvailableSpots[v] = npspot;
			}
		}
		
		//ObjRender_SetColor(obj, rand(96,255), rand(96,255), rand(96,255));
		
		MoveToScale;
		MoveToPosition;
		while(!EnemyDead){		
			ObjPrim_SetTexture(obj, currentFrameTexture);
			ObjSprite2D_SetSourceRect(obj, dx-ls/2, dy-ws/2, dx+ls/2, dy+ws/2);
			ObjSprite2D_SetDestCenter(obj);
			yield;
		}
		
		task MoveToPosition{
			while(!Obj_IsDeleted(obj)&&!(rx==np[0]&&ry==np[1])){
				let mx = np[0]-rx;
				let my = np[1]-ry;
				if(absolute(np[0]-rx)>3){
					rx+=mx/35;
				}else{rx = np[0];}
				if(absolute(np[1]-ry)>3){
					ry+=my/35;
				}else{ry = np[1];}
				ObjRender_SetPosition(obj, rx-32, ry-16, 0);
				yield;
			}
			ObjRender_SetPosition(obj, np[0]-32, np[1]-16, 0);
		}
		task MoveToScale{
			let xscale = 1;
			let yscale = 1;
			let nxs = round(rand(0, 1));
			let nys = round(rand(0, 1));
			if(nxs==1&&nys==1){return;}
			
			ascent(i in 0..80){
				let mod = i/80;
				if(nxs == 0){xscale = 1-2*mod;}
				if(nys == 0){yscale = 1-2*mod;}
				ObjRender_SetScaleXYZ(obj, xscale, yscale, 1);
				yield;
			}
			if(nxs == 0){xscale = -1;}
			if(nys == 0){yscale = -1;}
			ObjRender_SetScaleXYZ(obj, xscale, yscale, 1);
		}
		Obj_Delete(obj);
	}
}


task TimeStopB1(obj, length){
	let renderTexture = GetReservedRenderTargetName(0);

	let objCurentFrame = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetPosition(objCurentFrame, GetStgFrameWidth/2, GetStgFrameHeight/2, 0);
	let frameskip = 0;
	let PlayerCoord = [GetPlayerX, GetPlayerY];
	Obj_SetRenderPriorityI(objCurentFrame, 39);
	SetInvalidRenderPriorityA1(30, 38);
	
	let currentFrameTexture = renderTexture;
	RenderToTextureA1(currentFrameTexture, 30, 38, true);
	ObjPrim_SetTexture(objCurentFrame, currentFrameTexture);
	ObjSprite2D_SetSourceRect(objCurentFrame, 32, 16, 416, 464);
	ObjSprite2D_SetDestCenter(objCurentFrame);
	
	while(length>0&&!Obj_IsDeleted(obj)){
		ObjMove_SetPosition(GetPlayerObjectID, PlayerCoord[0], PlayerCoord[1]);
		length--;
		yield;
	}
	
	Obj_Delete(objCurentFrame);
	ClearInvalidRenderPriority;
}

task Shadow(x, y, incremental, alpha, colorR, colorG, colorB, stime){

	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	let ShadowTime = 0;
	let xBend = 1;
	let yBend = 1;
	let BendInc = 0.22;
	let ShadSet = 0;
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, 0.69);
	ObjRender_SetAlpha(obj, alpha);
	ObjPrim_SetTexture(obj, img_effect2);
	ObjSprite2D_SetSourceRect(obj, 0, 130, 62, 192);
	ObjSprite2D_SetDestRect(obj, -xBend, -xBend, xBend, xBend);
	ObjRender_SetPosition(obj, x, y, 0);
	ObjRender_SetColor(obj, colorR, colorG, colorB);
		while(Obj_IsDeleted(obj) == false){
		ShadowTime++;
		ObjSprite2D_SetDestRect(obj, -xBend, -xBend, xBend, xBend);
		
		if(xBend<1500&&ShadSet==0){
			xBend+=BendInc;
			BendInc+=incremental;
		}
		if(ShadowTime>stime&&ShadSet==0){
			BendInc=0;		
			ShadSet=2;
		}
		if(ShadowTime>stime&&ShadSet==2){
			xBend+=BendInc;
			BendInc-=incremental*1.75;
		}
		if(xBend<-20){Obj_Delete(obj);}
		yield;
	}
}

task SpellTime(SpellTimeSceneObjectID){
	//@Mainloop
	let GetTimer = ObjEnemyBossScene_GetInfo(SpellTimeSceneObjectID, INFO_TIMER);
	if(bosstime != GetTimer && GetTimer <11){
		if(GetTimer > 4){PlaySoundB1("se_timeout", 100)}
		if(GetTimer < 5 && GetTimer>-1){PlaySoundB1("se_timeout2", 100);}
		bosstime = GetTimer;
	}
	if(argument>=120){
		if(ObjEnemyBossScene_GetInfo(SpellTimeSceneObjectID, INFO_TIMERF)==1){
			ascent(i in 0..12){
				// let a = CreateObjShotA1(GetPlayerX, GetPlayerY, 3.5, (360/12)*i, FIRE_RED, 15);
				// ObjShot_SetSpellResist(a, true);
			}
		}
	}
}

task PlayTimerA1(GetTimer){
	if(bosstime != GetTimer && GetTimer <11){
		if(GetTimer > 4){PlaySoundB1("se_timeout", 100)}
		if(GetTimer < 5 && GetTimer>-1){PlaySoundB1("se_timeout2", 100);}
		bosstime = GetTimer;
	}
}

task TimeStop(tX, tY, length){
	SetCommonData("TimeStop", 1);
	LastTimeStop = length;
	IsTimeStopped = true;
	Shadow(tX, tY, 1.45, 165, 1, 1, 1, length-25);
	ascent(time in 0..length){
		yield;
	}
	SetCommonData("TimeStop", 0);
	IsTimeStopped = false;
	ScreenFlash(ID_INVALID, -10, 50);
	ScreenShakeA1(15, 1.75);
}

task TimeSlow(divide, length){
	SetCommonData("TimeSlow", divide);
	ascent(time in 0..length){
		yield;
	}
	SetCommonData("TimeSlow", 0);
}


function CreateObjShotA1(x, y, spd, ang, graph, delay){
	let shot = ObjShot_Create(OBJ_SHOT);
	CreateObjShotAC1(shot, x, y, spd, ang, graph, delay);
	Obj_SetValue(shot, "Damage", 28+argument/3);
	return shot;
}

function CreateObjShotA2(x, y, spd, ang, acc, maxspd, graph, delay){
	let shot = ObjShot_Create(OBJ_SHOT);
	CreateObjShotAC1(shot, x, y, spd, ang, graph, delay);
	// ObjMove_SetAcceleration(shot, acc);
	// ObjMove_SetMaxSpeed(shot, maxspd);
	SetAccandSpd;
	return shot;
	
	
	task SetAccandSpd{
		loop(delay){yield;}
		ObjMove_SetAcceleration(shot, acc);
		ObjMove_SetMaxSpeed(shot, maxspd);
	}
}

task CreateObjShotAC1(objShot, x, y, spd, ang, graph, delay){
	ObjShot_Regist(objShot);
	ObjMove_SetPosition(objShot, x, y);
	ObjMove_SetAngle(objShot, ang);
	ObjShot_SetGraphic(objShot, graph);
	ObjShot_SetIntersectionEnable(objShot, false);
	
	Obj_SetValue(objShot, "g_Coll_Ignore_Spawning", true);
	let i = 0;
	while(i<delay&&!Obj_IsDeleted(objShot)){
		let alpf = i*(225/delay);
		let scl = (delay-i)*(1.75/delay);
		ObjRender_SetScaleXYZ(objShot, scl+1, scl+1, 1);
		ObjRender_SetAlpha(objShot, min(255, alpf-35));
		i+=1/TimeSpeed;
		yield;
	}
	// ObjShot_SetIntersectionEnable(objShot, true);
	Obj_SetValue(objShot, "g_Coll_Ignore_Spawning", false);
	GiveCollision(objShot);
	ObjRender_SetScaleXYZ(objShot, 1, 1, 1);
	ObjRender_SetAlpha(objShot, 255);
	ObjMove_SetSpeed(objShot, spd);	
	// if(quality<=1){return;}
	// while(!Obj_IsDeleted(objShot)){
		// x = ObjRender_GetX(objShot);
		// y = ObjRender_GetY(objShot);
		// yield;
	// }
	// ObjShot_BulletBreak(x, y, graph)
}

function CreateObjShotB1(x, y, xspd, yspd, graph, delay){
	let shot = ObjShot_Create(OBJ_SHOT);
	CreateObjShotBC1(shot, x, y, xspd, yspd, 0, 0, xspd, yspd, graph, delay);
	return shot;
}

function CreateObjShotB2(x, y, xspd, yspd, xacel, yacel, xsmax, ysmax, graph, delay){
	// let shot = ObjShot_Create(OBJ_SHOT);
	let shot = CreateShotB2(x, y, xspd, yspd, xacel, yacel, xsmax, ysmax, graph, 0);
	CreateObjShotBC1(shot, x, y, xspd, yspd, xacel, yacel, xsmax, ysmax, graph, delay);
	return shot;
}

task CreateObjShotBC1(objShot, x, y, xspd, yspd, xacel, yacel, xsmax, ysmax, graph, delay){
	// ObjShot_Regist(objShot);
	// ObjMove_SetPosition(objShot, x, y);
	// let ang = AngleToLocation(x, y, x+xspd, y+yspd);
	// let spd = GetDistance(x, y, x+xspd, y+yspd);
	// ObjMove_SetAngle(objShot, ang);
	// ObjShot_SetGraphic(objShot, graph);
	
	ObjShot_SetIntersectionEnable(objShot, false);
	Obj_SetValue(objShot, "g_Coll_Ignore_Spawning", true);
	let i = 0;
	while(i<delay&&!Obj_IsDeleted(objShot)){
		let alpf = i*(225/delay);
		let scl = (delay-i)*(1.75/delay);
		ObjRender_SetScaleXYZ(objShot, scl+1, scl+1, 1);
		ObjRender_SetAlpha(objShot, min(255, alpf-35));
		i+=1/TimeSpeed;
		yield;
	}
	// ObjShot_SetIntersectionEnable(objShot, true);
	Obj_SetValue(objShot, "g_Coll_Ignore_Spawning", false);
	GiveCollision(objShot);
	ObjRender_SetScaleXYZ(objShot, 1, 1, 1);
	ObjRender_SetAlpha(objShot, 255);
	// ObjMove_SetSpeed(objShot, spd);	
	// if(quality<=1){return;}
	// while(!Obj_IsDeleted(objShot)){
		// x = ObjRender_GetX(objShot);
		// y = ObjRender_GetY(objShot);
		// yield;
	// }
	// ObjShot_BulletBreak(x, y, graph)
}

task CreateArrowShotA1(x, y, spd, ang, graph, delay,r,g,b){
	RaiseError("Defunct task");
	let objShot = CreateShotA1(x, y, 0,  ang, graph, 0);
	ObjShot_SetIntersectionEnable(objShot, false);
	let i = 0;
	while(i<delay&&!Obj_IsDeleted(objShot)){
		let alpf = i*(225/delay);
		let scl = (delay-i)*(1.75/delay);
		ObjRender_SetScaleXYZ(objShot, scl+1, scl+1, 1);
		ObjRender_SetAlpha(objShot, min(255, alpf-35));
		i+=1/TimeSpeed;
		yield;
	}
	ObjShot_SetIntersectionEnable(objShot, true);
	ObjRender_SetScaleXYZ(objShot, 1, 1, 1);
	ObjRender_SetAlpha(objShot, 255);
	ObjMove_SetSpeed(objShot, spd);	
	let A = 0;
	while(!Obj_IsDeleted(objShot)){
		x = ObjMove_GetX(objShot);
		y = ObjMove_GetY(objShot);
		A = ObjMove_GetAngle(objShot);
		ObjShot_SetIntersectionCircleA2(objShot, x+8*cos(A),  y+8*sin(A), 2);
		yield;
	}
	// if(quality<=1){return;}
	// ObjShot_BulletBreak(x, y, graph)
}

task CreateObjLaserA1(x, y, ang, llen, lwid, del, delay, r,g,b){
	//Shou laser still WIP
	//let objLaser = CreateStraightLaserA1(x+1*cos(ang-90), y, ang, llen, lwid/1.35, del, DS_BEAM_WHITE, delay);
	let objLaser = ID_INVALID;
	let btime = 0;
	let animscroll = 0;
	let anim = 0;
	let realsize = lwid/16;
	
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	ObjPrim_SetTexture(obj, img_laser);
	Obj_SetRenderPriority(obj, GetShotRenderPriorityI/100);
	SetNewPosition;
	ObjRender_SetPosition(obj, x, y, 0);
	ObjRender_SetAngleZ(obj, ang);
	ObjRender_SetColor(obj, r, g, b);
	
	let objDelay = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(objDelay, BLEND_ALPHA);
	ObjPrim_SetTexture(objDelay, img_laser);
	Obj_SetRenderPriority(objDelay, GetShotRenderPriorityI/100+0.01);
	ObjSprite2D_SetSourceRect(objDelay, 0, 128, 128, 256);
	ObjSprite2D_SetDestRect(objDelay, 0, -64, 128, 64);
	ObjRender_SetPosition(objDelay, x, y, 0);
	ObjRender_SetAngleZ(objDelay, ang);
	ObjRender_SetColor(objDelay, r, g, b);
	ObjRender_SetScaleXYZ(objDelay, 1.5, 1.5, 1);
	
	while(delay>0){
		SetNewDelay;
		delay--;
		yield;
	}
	while(realsize<lwid){
		SetNewDelay;
		SetNewPosition;
		realsize += (lwid/12);
		yield;
	}
	
	realsize = lwid;
	
	while(!Obj_IsDeleted(objLaser)&&btime<del+2){
		SetNewDelay;
		SetNewPosition;
		btime++;
		x = ObjRender_GetX(objLaser);
		y = ObjRender_GetY(objLaser);
		yield;
	}
	
	while(realsize>0){
		SetNewPosition;
		realsize = max(realsize-lwid/20, 0);
		yield;
	}

	Obj_Delete(obj);
	Obj_Delete(objDelay);
	
	function SetNewPosition{
		ObjSprite2D_SetSourceRect(obj, animscroll, 0, llen+animscroll, 32);
		ObjSprite2D_SetDestRect(obj, 0, -realsize/2, llen, realsize/2);
		animscroll-=8;
	}
	function SetNewDelay{
		ObjSprite2D_SetSourceRect(objDelay, 128*round(anim), 128, 127+128*round(anim), 256);
		anim+=0.25;
		if(anim>1){anim = 0;}
	}
}

task ObjShot_ReserveBreak(obj,graph){
	RaiseError("stop this ObjShot_ReserveBreak");
	let xy = [ObjMove_GetX(obj), ObjMove_GetY(obj)];
	while(!Obj_IsDeleted(obj)){
		xy = [ObjMove_GetX(obj), ObjMove_GetY(obj)];
		yield;
	}
	ObjShot_BulletBreak(xy[0], xy[1], graph);
}

task ObjShot_BulletBreak(x, y, graph){
	if(x<0||y<0||x>GetStgFrameWidth||y>GetStgFrameHeight){return;}
	while(IsTimeStopped){yield;}
	let bcol = GetShotDataInfoA1(graph, TARGET_ENEMY, INFO_DELAY_COLOR);
	let brect = GetShotDataInfoA1(graph, TARGET_ENEMY, INFO_RECT);
	
	let spin = 1;
	if(rand(0, 1)>0.5){spin = -1;}
	
	let scale = max(max(absolute(brect[0] - brect[2]), absolute(brect[1] - brect[3])), 4)^0.1;
	scale *= 0.4;
	
	let bangle = rand(0, 360);
	// let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	// let btime = 0;
	// ObjRender_SetBlendType(obj, BLEND_ALPHA);
	// ObjPrim_SetTexture(obj, img_break);
	// Obj_SetRenderPriority(obj, 0.49);
	// ObjRender_SetAlpha(obj, 205);
	// ObjSprite2D_SetSourceRect(obj, 0, 0, 32, 32);
	// ObjSprite2D_SetDestCenter(obj);
	// ObjRender_SetColor(obj, bcol[0], bcol[1], bcol[2]);
	// ObjRender_SetPosition(obj, x+rand(-3,3)*cos(rand(0,360)), y+rand(-3,3)*sin(rand(0,360)), 0);
	// ObjRender_SetAngleZ(obj, bangle);
	// ObjRender_SetScaleXYZ(obj, scale*spin, scale, 0);
	
	let xc = 64;
	let yc = 64;
	
	let bx = x+rand(-3,3)*cos(rand(0,360));
	let by = y+rand(-3,3)*sin(rand(0,360));
	
	let r = bcol[0];
	let g = bcol[1];
	let b = bcol[2];
	
	ascent(x in 0..8*3-1){
		let amod = round(x/3);
		ObjSpriteList2D_SetSourceRect(BreakRender, xc*amod, 0, xc*(amod+1), yc);
		ObjSpriteList2D_SetDestCenter(BreakRender);
		ObjRender_SetColor(BreakRender, r, g, b);
		ObjRender_SetPosition(BreakRender, bx, by, 0);
		ObjRender_SetAngleZ(BreakRender, bangle);
		ObjRender_SetScaleXYZ(BreakRender, scale*spin, scale, 0);
		ObjSpriteList2D_AddVertex(BreakRender);
		yield;
	}
	
	/*
	while(btime<18){
		if(!IsTimeStopped){
			if(floor(btime)==2){ObjSprite2D_SetSourceRect(obj, 32, 0, 64, 32);}
			if(floor(btime)==4){ObjSprite2D_SetSourceRect(obj, 64, 0, 96, 32);}
			if(floor(btime)==6){ObjSprite2D_SetSourceRect(obj, 96, 0, 128, 32);}
			if(floor(btime)==8){ObjSprite2D_SetSourceRect(obj, 128, 0, 160, 32);}
			if(floor(btime)==10){ObjSprite2D_SetSourceRect(obj, 128, 0, 160, 32);}
			if(floor(btime)==12){ObjSprite2D_SetSourceRect(obj, 160, 0, 192, 32);}
			if(floor(btime)==14){ObjSprite2D_SetSourceRect(obj, 192, 0, 224, 32);}
			if(floor(btime)==16){ObjSprite2D_SetSourceRect(obj, 224, 0, 256, 32);}
			btime+=0.75;
		}
		yield;
	}*/
	// Obj_Delete(obj);
}

task ObjShot_AddTimeStopA1(objID, spd){	
	let tspd = 1;
	while(!Obj_IsDeleted(objID)){
		tspd = GetCommonData("TimeSlow", 1);
		if(GetCommonData("TimeStop", 0) > 0){
			ObjMove_SetSpeed(objID, 0);
		}else{
			ObjMove_SetSpeed(objID, spd/tspd);
		}
		yield;
	}
}	

task ObjShot_AddCollisionA1(shotobjid, dX, dY){
	let X = ObjRender_GetX(shotobjid);
	let Y = ObjRender_GetY(shotobjid);
	let A = ObjMove_GetAngle(shotobjid);
	while(!Obj_IsDeleted(shotobjid)){
		X = ObjRender_GetX(shotobjid);
		Y = ObjRender_GetY(shotobjid);
		A = ObjMove_GetAngle(shotobjid);
		if(X<=dX-1 || X>=dX+1){
			ObjMove_SetAngle(shotobjid, 180-A);
		}	
		if(Y<=dY-1 || Y>=dY+1){	
			ObjMove_SetAngle(shotobjid, 360-A);
		}
		yield;
	}
}

task ObjShot_AddCollisionB1(shotobjid, radius){
	let X = ObjRender_GetX(shotobjid);
	let Y = ObjRender_GetY(shotobjid);
	let A = ObjMove_GetAngle(shotobjid);
	let barray = GetShotIdInCircleA2(X, Y, radius, TARGET_ENEMY);
	while(!Obj_IsDeleted(shotobjid)){
		X = ObjRender_GetX(shotobjid);
		Y = ObjRender_GetY(shotobjid);
		A = ObjMove_GetAngle(shotobjid);
		barray = GetShotIdInCircleA2(X, Y, radius, TARGET_ENEMY);
		if(length(barray)>0){
			let b = barray[0];
			let dX = ObjRender_GetX(b);
			let dY = ObjRender_GetY(b);
			if(X<=dX-1 || X>=dX+1){
				ObjMove_SetAngle(shotobjid, 180-A);
			}
			if(Y<=dY-1 || Y>=dY+1){	
				ObjMove_SetAngle(shotobjid, 360-A);
			}
		}
		yield;
	}
}

task ObjShot_AddCollisionB2(shotobjid, radius){
	let X = ObjRender_GetX(shotobjid);
	let Y = ObjRender_GetY(shotobjid);
	let A = ObjMove_GetAngle(shotobjid);
	let barray = GetShotIdInCircleA2(X, Y, radius, TARGET_ENEMY);
	let blength = length(barray);
	while(!Obj_IsDeleted(shotobjid)){
		X = ObjRender_GetX(shotobjid);
		Y = ObjRender_GetY(shotobjid);
		A = ObjMove_GetAngle(shotobjid);
		barray = GetShotIdInCircleA2(X, Y, radius, TARGET_ENEMY);
		blength = length(barray);
		if(blength>0){
			ascent (i in 0..blength){
				let b = barray[i];
				let dX = ObjRender_GetX(b);
				let dY = ObjRender_GetY(b);
				if(X<=dX-1 || X>=dX+1){
					ObjMove_SetAngle(shotobjid, 180-A);
					ObjMove_SetAngle(b, 180+(180-A));
				}
				if(Y<=dY-1 || Y>=dY+1){	
					ObjMove_SetAngle(shotobjid, 180-A);
					ObjMove_SetAngle(b, 180+(180-A));
				}
			}
		}
		yield;
	}
}




task ObjEnemy_OnHitBombA1(objid){
	if(quality<=1){return;}
	let hp = ObjEnemy_GetInfo(objid, INFO_LIFE);
	let hit = 0;
	while(Obj_IsDeleted(objid) == false){
		if(IsPlayerSpellActive == true){
			if(hp > ObjEnemy_GetInfo(objid, INFO_LIFE)){hit++; hp = ObjEnemy_GetInfo(objid, INFO_LIFE);}else{hp = ObjEnemy_GetInfo(objid, INFO_LIFE);}
			if(hit>7-quality){loop(quality*2){CreateEffect(ObjMove_GetX(objid), ObjMove_GetY(objid));} hit = 0;}
		}else{hit = 0;}
		yield;
	}
	task CreateEffect(deX, deY){
		let angZ = rand(0,360);
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		Obj_SetRenderPriority(obj, 0.60);
		ObjPrim_SetTexture(obj, img_effect);
		ObjSprite2D_SetSourceRect(obj, 64, 16, 129, 80);
		ObjSprite2D_SetDestCenter(obj);
		ObjRender_SetPosition(obj, deX, deY, 0);
		
		let alpha = 205;
		let scale = 0.25;
		let scaleinc = rand(0.35, 0.45);
		let randX = rand(-500, 500);
		let randY = rand(-500, 500);
		let randspin = rand(6,10);
		while(Obj_IsDeleted(obj)==false && scale>0 && alpha>0){
			scaleinc += -0.05;
			scale += max(-0.05, scaleinc);
			alpha += -0.1;
			deX += randX/100-scaleinc;
			deY += randY/100-scaleinc;
			angZ += randspin;
			
			ObjRender_SetPosition(obj, deX, deY, 0);
			ObjRender_SetAngleZ(obj, angZ);
			ObjRender_SetAlpha(obj, alpha);
			ObjRender_SetScaleXYZ(obj, scale, scale, scale);
			
			yield;
		}
		Obj_Delete(obj);
}

}


task ImageOverImageA1(obj, path, InX, InY, radset){
	let countVertex = 64;
	ObjPrim_SetPrimitiveType(obj, PRIMITIVE_TRIANGLEFAN);
	ObjPrim_SetVertexCount(obj, countVertex);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	ObjRender_SetAlpha(obj, 255);
	Obj_SetRenderPriority(obj, 0.3);
	ObjPrim_SetTexture(obj, path);
	ascent(iVert in 0..countVertex){
		let angle = (360 / (countVertex - 1) * iVert);
		let x = InX+radset*cos(angle);
		let y = InY+radset*sin(angle);
		ObjPrim_SetVertexUVT(obj, iVert, x, y);	
		x = radset*cos(angle);
		y = radset*sin(angle);
		ObjPrim_SetVertexPosition(obj, iVert , x, y, 0);
	}
}

task SetNewImageRender(obj, InX, InY, radset){
	let countVertex = 64;
	ascent(iVert in 0..countVertex){
		let angle = (360 / (countVertex - 1) * iVert);
		let x = InX+radset*cos(angle);
		let y = InY+radset*sin(angle);
		ObjPrim_SetVertexUVT(obj, iVert, x, y);	
		x = radset*cos(angle);
		y = radset*sin(angle);
		ObjPrim_SetVertexPosition(obj, iVert , x, y, 0);
	}
}

function DrawTextA1(txtStr){
	let objTxt = ObjText_Create;
	ObjText_SetText(objTxt,txtStr);
	ObjText_SetFontSize(objTxt,14);
	ObjText_SetFontColorTop(objTxt,255,255,255);
	ObjText_SetFontColorBottom(objTxt,255,255,255);
	ObjText_SetFontBorderType(objTxt,BORDER_FULL);
	ObjText_SetFontBorderColor(objTxt,48,48,48);
	ObjText_SetFontBorderWidth(objTxt,1);
	ObjText_SetHorizontalAlignment(objTxt, ALIGNMENT_LEFT);
	ObjText_SetMaxWidth(objTxt, GetStgFrameWidth/2);
	Obj_SetRenderPriority(objTxt, 0.75);
	return objTxt;
}

task CreateSystemMessage(text, texlen){ 
	if(GetAreaCommonData("System", "Message_New_Text", "MESSAGE_NONE") != "MESSAGE_NONE"){yield;}
	SetAreaCommonData("System", "Message_New_Text", text);
	SetAreaCommonData("System", "Message_New_Length", texlen);
}

task GhostlyParticle(x, y, angX, deAlpha, scale){
	let newp = [0,0];
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, 0.51);
	ObjPrim_SetTexture(obj, img_effect);
	ObjSprite2D_SetSourceRect(obj, 0, 16, 64, 80);
	ObjSprite2D_SetDestCenter(obj);
	ObjRender_SetAngleXYZ(obj, 0, 0, angX);
	ObjRender_SetPosition(obj, x, y, 0);
	ObjRender_SetAlpha(obj, deAlpha);
	let randX = rand(3.5, 4.75);
	while(scale>0){
		scale += (-0.075)/TimeSpeed;
		newp[0] = newp[0]+(randX/TimeSpeed)*cos(angX)+(randX)-4.125;
		newp[1] = newp[1]+(randX/TimeSpeed)*sin(angX);
		ObjRender_SetPosition(obj, x+newp[0]-2, y+newp[1]+1, 0);	
		ObjRender_SetAngleXYZ(obj, 0, 0, angX+x+y+scale*45);
		ObjRender_SetScaleXYZ(obj, scale, scale, 1);
		yield;
	}
	Obj_Delete(obj);
}



function CreateSimple2DImageA1(pri, image){
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, pri);
	ObjPrim_SetTexture(obj, image);
	let test = [GetTextureWidth(image), GetTextureHeight(image)];
	ObjSprite2D_SetSourceRect(obj, 0, 0, test[0]-1, test[1]-1);
	ObjSprite2D_SetDestRect(obj, -(test[0]/2+0.5), -(test[1]/2), (test[0]/2), (test[1]/2));
	return obj;
}


//Complex but basic patterns

task FireEmbryoA1(x, y, len, oang, mod, graph){
	let ang = 270;
	
	if(mod == -1){ang = 90;}
	
	let ispd = rand(3, 4.5);
	let del = rand(0, 14);
	let angi = rand(1.5, 2.5);
	let bf = 0;
	
	ascent(i in 0..del){
		DoProperties;
	}
	
	ascent(i in 0..35){
		ang+=angi*sin(45+i*8)*mod;
		DoProperties;
	}
	let adiff = absolute(-120-ang);
	if(mod == -1){adiff = absolute(-320-ang);}
	let sdiff = absolute(0.4-ispd);
	
	ascent(i in 0..65){
		ang -= adiff/65*mod;
		ispd -= sdiff/65;
		DoProperties;
	}
	
	
	sub DoProperties{
		bf++;
		if(bf%1==0){
			let a = CreateObjShotA1(x, y, 0, oang+ang+90, graph, 8);
			ObjShot_SetDeleteFrame(a, 150);
		}
		x+=ispd*cos(ang+oang);
		y+=ispd*sin(ang+oang);
		yield;
	}
}





//Animation

//top left fairies 42x38 grid
//top right fairies 48x48 grid
//bottom 4 basic color fairies 32x32 grid
//bottom right; very bottom fairies 64x64 grid

task AnimateFairyA1(objID, presetColor){

	let anim_count = 0;
	let anim_type = 0;
	
	let xoffset = 0;
	let yoffset = 0;
	
	if(presetColor=="blue"){yoffset = 321}
	if(presetColor=="red"){yoffset = 353}
	if(presetColor=="green"){yoffset = 385}
	if(presetColor=="yellow"){yoffset = 417}
	
	loop{
		if(ObjMove_GetSpeed(objID) == 0){
			if(anim_type == 1){
				anim_type=2;
				anim_count = 0;
			}
		}
		if(ObjMove_GetSpeed(objID) > 3){
			if(anim_type != 1){
				anim_count = 0;
				anim_type = 1;
			}
		}
		if(CheckDirection(objID, "right") == true){ObjRender_SetScaleXYZ(objID, 1, 1, 1)}
		if(CheckDirection(objID, "left") == true){ObjRender_SetScaleXYZ(objID, -1, 1, 1)}
		//if(CheckDirection(objID, "none") == true){ObjRender_SetScaleXYZ(objID, 1, 1, 1)}
		
		if(anim_type==0){
			if(anim_count == 0){ObjSprite2D_SetSourceRect(objID, 0, yoffset, 32, yoffset+32);}
			if(anim_count == 5){ObjSprite2D_SetSourceRect(objID, 32, yoffset, 64, yoffset+32);}
			if(anim_count == 10){ObjSprite2D_SetSourceRect(objID, 64, yoffset, 96, yoffset+32);}
			if(anim_count == 15){ObjSprite2D_SetSourceRect(objID, 96, yoffset, 128, yoffset+32);}
			if(anim_count == 20){ObjSprite2D_SetSourceRect(objID, 64, yoffset, 96, yoffset+32);}
			if(anim_count == 25){ObjSprite2D_SetSourceRect(objID, 32, yoffset, 64, yoffset+32);}
			if(anim_count == 29){anim_count = 4;}
		}
		if(anim_type==1){
			if(anim_count == 0){ObjSprite2D_SetSourceRect(objID, 128, yoffset, 160, yoffset+32);}
			if(anim_count == 4){ObjSprite2D_SetSourceRect(objID, 160, yoffset, 192, yoffset+32);}
			if(anim_count == 8){ObjSprite2D_SetSourceRect(objID, 192, yoffset, 224, yoffset+32);}
			if(anim_count == 12){ObjSprite2D_SetSourceRect(objID, 224, yoffset, 256, yoffset+32);}
			if(anim_count == 16){ObjSprite2D_SetSourceRect(objID, 256, yoffset, 288, yoffset+32);}
			if(anim_count == 20){ObjSprite2D_SetSourceRect(objID, 288, yoffset, 320, yoffset+32);}
			if(anim_count == 24){ObjSprite2D_SetSourceRect(objID, 320, yoffset, 352, yoffset+32);}
			if(anim_count == 28){ObjSprite2D_SetSourceRect(objID, 352, yoffset, 384, yoffset+32);}
			if(anim_count == 31){anim_count = 11;}
		}
		if(anim_type==2){
			if(anim_count == 0){ObjSprite2D_SetSourceRect(objID, 224, yoffset, 256, yoffset+32);}
			if(anim_count == 3){ObjSprite2D_SetSourceRect(objID, 192, yoffset, 224, yoffset+32);}
			if(anim_count == 6){ObjSprite2D_SetSourceRect(objID, 160, yoffset, 192, yoffset+32);}
			if(anim_count == 9){ObjSprite2D_SetSourceRect(objID, 128, yoffset, 160, yoffset+32);}
			if(anim_count == 12){anim_count = 0;anim_type=0;}
		}
		
	
		ObjSprite2D_SetDestCenter(objID);
		anim_count++;
		yield;
	}
}

task AnimateBossA1(objID, x, y, bnam, re, g, b){
	// General, top four idle, second four moving
	let anim_count = 0;
	let anim_type = 0;
	AuraOnBossSingle(objID, re, g, b);
	if(bnam != ""){NameOnBossSingle(objID, bnam);}
	let xoffset = 0;
	let yoffset = 0;
	
	let idle = 7;
	let move = 5;
	let attack = 4;
	
	let r = idle; // Frames yielded before moving to next frame
	let ad = 35; // Frames yielded while "charging" attack animation
	let m = 0; 
	let xo = 0;
	let yo = 0;
	
	while(!Obj_IsDeleted(objID)){
		if(Anim_Attack==0){
			if(ObjMove_GetSpeed(objID) <= 1){
				if(anim_type == 1){
					anim_count = 0;
					anim_type = 2;
				}
				if(anim_type == 3){
					anim_type=4;
					anim_count = 0;
				}
			}
			if(ObjMove_GetSpeed(objID) > 1){
				if(anim_type == 0){
					anim_count = 0;
					anim_type = 1;
				}
			}
		}
		
		if(CheckDirection(objID, "right") == true){ObjRender_SetScaleXYZ(objID, 1, 1, 1)}
		if(CheckDirection(objID, "left") == true){ObjRender_SetScaleXYZ(objID, -1, 1, 1)}
		
		if(anim_type==0){ //Idle
			r = idle;
			if(anim_count >= 0){ObjSprite2D_SetSourceRect(objID, 0, 0, x, y);}
			if(anim_count >= r){ObjSprite2D_SetSourceRect(objID, x, 0, x*2, y);}
			if(anim_count >= r*2){ObjSprite2D_SetSourceRect(objID, x*2, 0, x*3, y);}
			if(anim_count >= r*3){ObjSprite2D_SetSourceRect(objID, x*3, 0, x*4, y);}
			if(anim_count >= r*4-1){anim_count = -1;}
		}
		if(anim_type==1){ //Moving
			r = move;
			if(anim_count >= 0){ObjSprite2D_SetSourceRect(objID, 0, y, x, y*2);}
			if(anim_count >= r){ObjSprite2D_SetSourceRect(objID, x, y, x*2, y*2);}
			if(anim_count >= r*2){ObjSprite2D_SetSourceRect(objID, x*2, y, x*3, y*2);}
		}
		if(anim_type==2){ //Moving to idle
			r = move;
			if(anim_count >= 0){ObjSprite2D_SetSourceRect(objID, x*2, y, x*3, y*2);}
			if(anim_count >= r){ObjSprite2D_SetSourceRect(objID, x, y, x*2, y*2);}
			if(anim_count >= r*2){ObjSprite2D_SetSourceRect(objID, 0, y, x, y*2);}
			if(anim_count >= r*3-r/2){anim_type=0; anim_count=0;}
		}
		
		m+=1.5;
		ObjSprite2D_SetDestRect(objID, -x/2, -y/2+(7*sin(m)), x/2, y/2+(7*sin(m)));
		if(!IsTimeStopped){anim_count++;}
		yield;
	}
}

task MoveObjToPositionA1(obj, x1, y1, spdmod, len){
	let ObjX = ObjRender_GetX(obj);
	let ObjY = ObjRender_GetY(obj);
	let dist = GetDistance(ObjX,ObjY,x1,y1)/spdmod;
	let gang = AngleToLocation(ObjX, ObjY, x1, y1);
	while(dist*spdmod>len){
		ObjX = ObjRender_GetX(obj);
		ObjY = ObjRender_GetY(obj);
		dist = GetDistance(ObjX,ObjY,x1,y1)/spdmod;
		ObjRender_SetX(obj, ObjX+dist*cos(gang));
		ObjRender_SetY(obj, ObjY+dist*sin(gang));
		yield;
	}
}

task ConnectLifeA1(original, destination){
	ObjEnemy_SetLife(destination, ObjEnemy_GetInfo(original, INFO_LIFE));
	ObjEnemy_SetDamageRate(destination, 0, 0);
	while(ObjEnemy_GetInfo(original, INFO_DAMAGE_RATE_SHOT)==0){yield;}
	ObjEnemy_SetDamageRate(destination, 
		ObjEnemy_GetInfo(original, INFO_DAMAGE_RATE_SHOT), 
		ObjEnemy_GetInfo(original, INFO_DAMAGE_RATE_SPELL));
}

task SyncronizeLifeA1(obj1, obj2, rate){
	let origlife = ObjEnemy_GetInfo(obj2, INFO_LIFE);
	let curlife = ObjEnemy_GetInfo(obj2, INFO_LIFE);
	let oldlife = curlife;
	
	while(curlife>0){
		curlife = ObjEnemy_GetInfo(obj2, INFO_LIFE);
		if(curlife<oldlife){
			let damage = (oldlife-curlife)*rate;
			oldlife = curlife;
			ObjEnemy_AddLife(obj1, -damage*(ObjEnemy_GetInfo(obj1, INFO_DAMAGE_RATE_SHOT)/100));
		}
		yield;
	}
}

function SyncronizeLifeB1(obj1, obj2){
	let life = [ObjEnemy_GetInfo(obj1, INFO_LIFE), ObjEnemy_GetInfo(obj2, INFO_LIFE)];
	if(life[0]==life[1]){return;}
	else if(life[0]>life[1]){
		ObjEnemy_SetLife(obj1, life[1]);
	}else if(life[1]>life[0]){
		ObjEnemy_SetLife(obj2, life[0]);
	}
}

function CheckDirection(checkid, direc){
	let direction = false;
	let enemyang = absolute(ObjMove_GetAngle(checkid));
	let enemyspd = absolute(ObjMove_GetSpeed(checkid));
	
	
	while(enemyang>360){
		enemyang = enemyang-360;
	}

	if(enemyspd > 0){
		if(direc=="right"){
			if(enemyang > 270 || enemyang-270 < 90){
				direction=true;
			}
		}
		if(direc=="left"){
			if(enemyang < 270 && enemyang > 90){
				direction=true;
			}
		}
	}
	if(direc=="none"){
		if(enemyspd == 0){
			direction=true;
		}
	}
	
	return direction;
}

function CheckOutsideScreenA1(objectID, distance){
	//if positive, distance INCREASES size of the stg box
	return ObjRender_GetX(objectID)>GetStgFrameWidth+distance||ObjRender_GetX(objectID)<-distance||
		ObjRender_GetY(objectID)>GetStgFrameHeight+distance||ObjRender_GetY(objectID)<-distance;
}

function CheckOutsideScreenA2(x, y, distance){
	return x>GetStgFrameWidth+distance||x<-distance||y>GetStgFrameHeight+distance||y<-distance;
}

function CheckInsideBox(x, y, l, t, r, b){
	return x > l && y > t && x < r && y < b;
}

function DigitToArray(digit, count){
	let res = [];
	digit = truncate(digit);

	loop{
		let tnum = truncate(digit % 10);
		digit /= 10;
		res = [tnum] ~ res;
		if(truncate(digit) == 0){break;}
	}

	loop(max(0, count - length(res))){
		res = [0] ~ res;
	}

	return res;
}

function IntToStringEx(number){
	let newnumber = itoa(floor(number));
	let newstr = "";
	ascent(i in 0..length(newnumber)){
		newstr = newstr~IntToString(atoi([newnumber[i]]));
		if(i%3==0&&i != length(newnumber)-1&&i>2){
			newstr = newstr~",";
		}
	}
	return newstr;
}

function GetNumSign(value){
	if(value<0){return -1;}else{return 1;}
}

function GetNumSize(value){
	if(value<=1){return 1;}
	else{return truncate(log10(value))+1;}
}

function GetDistance(x1,y1,x2,y2){
	return(((x2-x1)^2+(y2-y1)^2)^(1/2))
}

function GetAngleDistanceA1(ang1, ang2){
	let diff = ang2 - ang1;
	while(diff >= 180) { diff -= 360; }
	while(diff < -180) { diff += 360; }
	return diff;
}

function GetAngleDistanceA2(ang1, ang2){
	let diff = ang2 - ang1;
	while(diff >= 180) { diff -= 360; }
	while(diff < -180) { diff += 360; }
	let diffAbs = (|diff|);
	return diff / max(1, diffAbs);
}

function AngleToBoss(x, y){
	return atan2(EnemyY - y, EnemyX - x);
}

function AngleToPlayer(x, y){
	return atan2(GetPlayerY - y, GetPlayerX - x);
}

function AngleToLocation(x1, y1, x2, y2){
	return atan2(y2 - y1, x2 - x1);
}

function Hold(yielder){
	loop(yielder){
		if(EnemyDead){return false;}yield;
	}
	return true;
}

function HoldTime(yielder){
	loop(yielder){
		while(GetCommonData("IsTimeStopped", false)){yield;}
		if(EnemyDead){return false;}yield;
	}
	return true;
}

function HoldB(obj, yielder){
	loop(yielder){if(ObjEnemy_GetInfo(obj, INFO_LIFE)<=0||EnemyDead){return false;}yield;}
	return true;
}

function HoldTS(time, yielder){
	loop(yielder){
		if(ObjEnemyBossScene_GetInfo(objScene, INFO_TIMER) <= time){return false;}
		if(EnemyDead){return false;}yield;
	}
	return true;
}

function GetValueDistanceA1(v1, v2, div, i){
	return (v1-v2)/div*i;
}

function GetAnyKeyStateA1(type){
	let skck = false;
	if(GetVirtualKeyState(VK_LEFT) == type){skck=true;}
	if(GetVirtualKeyState(VK_RIGHT) == type){skck=true;}
	if(GetVirtualKeyState(VK_UP) == type){skck=true;}
	if(GetVirtualKeyState(VK_DOWN) == type){skck=true;}
	return skck;
}

function IsAllKeysFree{
	// let skck = false;
	// if(GetVirtualKeyState(VK_LEFT) == KEY_FREE &&
	// GetVirtualKeyState(VK_RIGHT) == KEY_FREE &&
	// GetVirtualKeyState(VK_UP) == KEY_FREE &&
	// GetVirtualKeyState(VK_DOWN) == KEY_FREE){skck=true;}
	return (GetVirtualKeyState(VK_LEFT) == KEY_FREE &&
	GetVirtualKeyState(VK_RIGHT) == KEY_FREE &&
	GetVirtualKeyState(VK_UP) == KEY_FREE &&
	GetVirtualKeyState(VK_DOWN) == KEY_FREE);
}

function GetRandomModifier{
	let a = round(rand(0, 1));
	if(a == 0){a = -1;}
	return a;
}

function GetRand(bot, top){
	CustomNum+=1;
	let lnum = top-bot;
	return bot+((((4820285*CustomNum)^2.23)%10000)/10000)*lnum
}

function CheckWithinBoundsX(x, off){
	return max(off, min(GetStgFrameWidth-off, x));
}
function CheckWithinBoundsY(y, off){
	return max(off, min(GetStgFrameHeight-off, y));
}

function GetFinalDirectoriesInPathA1(str, depth){
	depth = max(0, depth-1);
	let point = length(str);
	descent(i in 0..length(str)){
		if(str[i-1..i] == "/"){
			if(depth == 0){
				return str[i..point];
			}else{
				depth--;
			}
		}
	}
	RaiseError("GetFinalDirectoriesInPathA1 received an invalid path for the string.");
}

function GetPreviousDirectoryA1(str, depth){
	depth = max(0, depth-1);
	let point = length(str);
	descent(i in 0..length(str)){
		if(str[i-1..i] == "/"){
			if(depth == 0){
				return str[0..i];
			}else{
				depth--;
			}
		}
	}
	RaiseError("GetPreviousDirectoryA1 received an invalid path for the string.");
}



task BeginCustomPlural{
	if(GetCommonData("ScriptBuilderData", [""])[0] == ""){return;}
	
	//let Background = LoadScript(source ~ "background.h");
	//SetScriptArgument(Background, "PluralID", GetOwnScriptID);
	//StartScript(Background);
	
	ObjRender_SetPosition(Enemy, GetStgFrameWidth/3, -128, 0);
	ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/4, 10, 3);
	
	loop(54){yield;}
	//StarOnBossSingle(Enemy);
	
	while(!EnemyDead){yield;}
	loop(max(1,quality)){ExplosionSB1(EnemyX, EnemyY, "red", rand(-70, 70), rand(-70, 70), rand(-40, 40));}
	loop(quality*2){ExplosionSB2(EnemyX, EnemyY, 255, 102, 0, rand(1, 3));}
	PlaySoundB1("se_enep01", 100);
}

task FinalizeSpell{
	EnemyDead = true;
	PlaySoundA1("se_tan00");
	Obj_Delete(Enemy);
	ClearBullets(EnemyX, EnemyY, TYPE_ITEM, 128, 30, 500, 0);
	loop(argument/4+10){
		CreateItemA1(ITEM_POINT_S, EnemyX+rand(-60, 60), EnemyY+rand(-60, 60), rand(360, 3600));
		CreateItemA1(ITEM_POWER_S, EnemyX+rand(-60, 60), EnemyY+rand(-60, 60), 0.02);
	}
	if(argument >= 120){
		LastTimeStop+=160;
		ascent(i in 0..160){
			if(i%6==0){
				//CreateObjShotA1(EnemyX+rand(-15, 15), EnemyY+rand(-15, 15), argument/36+rand(3.75, 4.25), AngleToPlayer(EnemyX, EnemyY)+rand(-5,5), DS_RICE_M_RED, 20);
				PlaySoundB1("se_tan00", 90);
			}
			yield;
		}
	}	
}

task FinalizePlural(FinalX, FinalY){
	if(GetCommonData("ScriptBuilderData", [""])[0] != ""){FinalizeSpell;return;}
	EnemyDead = true;
	let finalframe = 0;

	ObjMove_SetDestAtWeight(Enemy, FinalX-48, FinalY-32, 130, 1);
	ExplosionSA1(FinalX, FinalY, 0, 0, 0);	
	loop(quality*20){ExplosionSA2(FinalX, FinalY, rand(-360, 360), rand(-360, 360), rand(-360, 360), rand(1, 3));}
	ScreenShakeA1(45,24);
	ClearBullets(FinalX, FinalY, TYPE_ITEM, 30, 10, 500, 0);
	PlaySoundA1("se_enep01");
	loop(60){
		if(finalframe>4){
			loop(quality+1){ExplosionSA2(FinalX, FinalY, rand(-360, 360), rand(-360, 360), rand(-360, 360), rand(2, 5));}
			finalframe = 0;
			PlaySoundB1("se_tan00", 80);
		}
		finalframe++;
		ScreenShakeA1(4,12);
		yield;
	}
	
	PlaySoundA1("se_enep01");
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(argument/2){
		CreateItemA1(ITEM_POINT_S, FinalX+rand(-60, 60), FinalY+rand(-60, 60), rand(360, 3600));
		CreateItemA1(ITEM_POWER_S, FinalX+rand(-60, 60), FinalY+rand(-60, 60), 0.15);
		ExplosionSA2(FinalX, FinalY, rand(-360, 360), rand(-360, 360), rand(-360, 360), rand(1, 7));}
	ScreenShakeA1(30,32);
	ExplosionSA1(FinalX, FinalY, 0, 0, 0);
	SetCommonData("StarX1", -400);
	SetCommonData("StarY1", -400);
	Obj_Delete(Enemy);
}

task FinalizeFairy(FinalX, FinalY, expcolor){
	if(CheckOutsideScreenA2(FinalX, FinalY, 32)){return;}
	let r = 128;
	let g = 128;
	let b = 128;
	if(expcolor=="blue"){r=50;g=84;b=255}
	if(expcolor=="green"){r=0;g=238;b=0}
	if(expcolor=="red"){r=255;g=102;b=0}
	if(expcolor=="yellow"){r=255;g=238;b=0}
	loop(max(1,quality)){ExplosionSB1(FinalX, FinalY, expcolor, rand(-70, 70), rand(-70, 70), rand(-40, 40));}
	loop(quality*2){ExplosionSB2(FinalX, FinalY, r, g, b, rand(1, 3));}
	PlaySoundB1("se_enep00", 100);
}


local{
	BreakRender = InitRender(BreakRender, 0.49, img_break);
}


