#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["Nonspell1"]
#text["Nonspell1"]
#System["./../../../ds_system/S_System.txt"]

#include"./../../../ds_system/Function_Effect.dnh"
#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"

let Boss;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "boss.png";
let timer = -70;

#include "./AchyShot_const.cs"

@Initialize {

	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	
	ObjPrim_SetTexture(Boss,imgBoss);
	ObjSprite2D_SetSourceRect(Boss,0,0,110,145);
	ObjSprite2D_SetDestCenter(Boss); 
	ObjMove_SetPosition(Boss,192,-120);
	SetEnemyAnimationA1(Boss);
	
	ObjMove_SetDestAtSpeed(Boss,GetStgFrameWidth/2,GetStgFrameHeight/3,5);
	SetInvincibility(Boss, 180, 70, 56);
	mainTask;
	Ending;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(2500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(60);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,24);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,24);
	
	timer++;
	if (timer == -1) {ConcentrationA1(Boss,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);}
	if (timer == 750) {timer = 0;}
	if (timer == 150) {pt1(-1,19,rand(240,270));}
	if (timer == 250) {pt1(1,17,rand(270,300));}
	
	if (timer == 550) {pt1(1,19,rand(240,270));}
	if (timer == 650) {pt1(-1,17,rand(270,300));}
	
	yield;
	
}

@Finalize {

}


task mainTask {
	wait(540);
	spam;
}

task pt1(way,color,startingpoint) {
	let dir = startingpoint;
	let count = 0;
	let flux = 0;
	let skip = 0;
	loop(50){
		count+=360/50;
		flux+=1.5*sin(count);
		dir-=360/40*way;
		let variety = 0;
		skip++;
		ascent(i in 0..flux/2){
			CreateCollisionShotA1(BossX+60*cos(dir),BossY+20*sin(dir),0.8+(i*0.25),dir+variety,color,10);
			variety-=1*way;
		}
		if (skip%2 == 0) {wait(1); PlaySoundB1("se_tan00", 45);};
	}
}

task spam{
	SpellBurstA1(BossX,BossY,"CHERRY",[255,255,0]);
	PlaySoundB1("se_enep02", 65);
	wait(10);
	loop{
		let ang = GetAngleToPlayer(Boss);
		let spread = -80;
		loop(5){
			CreateCollisionShotA2(BossX+rand(-20,20),BossY+rand(-20,20),10,ang+spread+rand(-14,14),-0.3,2,47,10);
			spread+=40;
		}
		PlaySoundB1("se_tan01", 40);
		wait(20);
	}
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	EnemyDead = true;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	PlaySoundB1("se_tan00",100);
	Obj_Delete(Boss);
	SetAutoDeleteObject(true);
	CloseScript(GetOwnScriptID());
}