


#include"./../BackgroundFunctions.txt"


let source = GetCurrentScriptDirectory;


@Initialize{
	SetAutoDeleteObject(true);
	SetCommonData("stgspeed", 3);
	SetCommonData("BossEnding", false);
	StageBg1;
}

@MainLoop{
	let a = GetEnemyBossSceneObjectID;
	stgspeed = GetCommonData("stgspeed", 3); // this should only be changed in the boss's final sc
	//a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL) | GetKeyState(KEY_H)!=KEY_FREE
	if(a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL)){SpellActive = true;}else{SpellActive = false;}
	if(stgspeed > 3){SpellActive = false;}
	yield;
}

task StageBg1{
	let stg1src = source;
	
	// let clock = GetCurrentDateTimeS;
	// let clen = length(clock);
	
	// let cint = atoi(clock[clen-6..clen-4]);
	
	// WriteLog("Time:");
	// WriteLog(cint);
	
	// stgtime = 0.1+0.7/11*cint;
	stgtime = 0.5;
	stgspeed = 2.5;
	FullCameraReset;
	BackgroundRenderControl;
	
	let treetops = [];
	let clouds = [];
	
	// let Skybox = CreateSkyBox(1);
	SetCameraPerspectiveClip(10, 2000);
	
	// ObjRender_SetColor(Skybox, 164, 180, 244);
	let Skybox = CreateSkyBox(0.6);
	ObjRender_SetColor(Skybox, 0, 4, 32);
	
	let naturalcol = 255*stgtime;
	let farcol = min(0, 128*stgtime-127);
	
	let Grass = Create3DEnvironment(stg1src~"bg1.png", 256, 0.2);
	ObjSprite3D_SetDestRect(Grass, -768, 0, 768, 1024);
	ObjRender_SetColor(Grass, naturalcol, naturalcol, naturalcol);
	
	CreateScreenCoverA1(128*stgspeed, 212*stgspeed, 255*stgspeed);
	
	ObjPrim_SetVertexColor(Grass, 0, naturalcol*0.5, naturalcol*0.5, naturalcol);
	ObjPrim_SetVertexColor(Grass, 2, naturalcol*0.5, naturalcol*0.5, naturalcol);
	ObjPrim_SetVertexColor(Grass, 3, farcol, farcol, farcol);
	ObjPrim_SetVertexColor(Grass, 1, farcol, farcol, farcol);
	
	ObjRender_SetZ(Grass, 32);
	
	let Sky = Create3DEnvironmentB1(stg1src~"bg3.png", 256, 418, 0.2);
	ObjSprite3D_SetDestRect(Sky, -1024, 0, 1024, 640);
	ObjRender_SetColor(Sky, naturalcol, naturalcol, naturalcol);
	ObjRender_SetAngleX(Sky, 90);
	ObjRender_SetPosition(Sky, 0, 1000, -580);
	
	
	let Stars = Create3DEnvironmentB1(stg1src~"bg2b.png", 1024, 418, 0.2);
	ObjSprite3D_SetDestRect(Stars, -512, 0, 512, 418);
	ObjRender_SetColor(Stars, 96, 96, 96);
	ObjRender_SetAngleX(Stars, 90);
	ObjRender_SetPosition(Stars, 0, 1000, -580);
	
	ObjPrim_SetVertexColor(Stars, 0, 32, 32, 96);
	ObjPrim_SetVertexColor(Stars, 2, 32, 32, 96);
	ObjPrim_SetVertexColor(Stars, 3, 96, 96, 96);
	ObjPrim_SetVertexColor(Stars, 1, 96, 96, 96);
	
	ObjPrim_SetVertexAlpha(Stars, 0, 255);
	ObjPrim_SetVertexAlpha(Stars, 2, 255);
	ObjPrim_SetVertexAlpha(Stars, 3, 96);
	ObjPrim_SetVertexAlpha(Stars, 1, 96);
	
	// descent(i in 0..4){
		// let a = Create3DEnvironment(bgsource~"Stage 3/test.png", 512, 0.2);
		// ObjSprite3D_SetDestRect(a, -512*2, -512*2, 512*2, 512*2);
		// ObjRender_SetColor(a, 33, 144, 55);
		// ObjRender_SetZ(a, -16*i);
		// ObjRender_SetAlpha(a, 43+32*i);
		// ObjRender_SetAngleZ(a, rand(0, 360));
		// treetops = treetops~[a];
	// }
		treetops = treetops~[Grass];
	let amove = 0;
	// CameraFlight;
	
	MoveCameraToPositionC1(2, 0, 350, -15);
	MoveCameraToPositionA1(2, 144, 96, 450);
	yield;
	
	MoveCameraToPositionA1(200, 0, 0, 0);
	MoveCameraToPositionC2(200, 0, 360-77, 7);
	
	// CreateFakeFogA1(600, 3000, 1000, 32, 1, 0.1, 144, 144, 144);
	FiringCloudsTask;
	
	let cammove = 0;
	while(RunningCondition){
		cammove+=stgspeed/15;
		SetCameraYaw(7*cos(cammove));
		RenderMove;
		yield;
	}
	
	Obj_Delete(Skybox);
	Obj_Delete(Sky);
	Obj_Delete(Grass);
	Obj_Delete(Stars);
	
	ascent(i in 0..length(treetops)){
		Obj_Delete(treetops[i]);
	}
	
	sub RenderMove{
		amove+=4;
		ascent(i in 0..1){
			let a = treetops[i];
			let lmove = amove/(3-i/5);
			// ObjSprite3D_SetSourceRect(a, -512+lmove+37*i, -512+lmove+47*i, 512+lmove+37*i, 512+lmove+47*i);
			//approximations because lazy
			ObjSprite3D_SetSourceRect(a, -3112+lmove+37*i, -2024+lmove+47*i, 3112+lmove+37*i, 2024+lmove+47*i);
		}
	}
}


task FiringCloudsTask{
	while(RunningCondition){
		let dist = rand(600, 1000);
		FireCloudA1(rand(400, 700), dist, -rand(55, 400), rand(-stgspeed*0.5, -stgspeed)*800/dist, rand(-stgspeed, -stgspeed*2)/7, rand(-0.1, 0.1), 90, 210, round(rand(0, 9)));
		loop(13){yield;}
	}
}

task FireCloudA1(x, y, z, mx, my, mz, del, dur, type){
	let cloudimg = source~"Cloud"~IntToString(type)~".png";
	let obj = Create3DEnvironmentB1(cloudimg, 10, 10, 0.21);
	let lcmod = stgtime*0.75;
	ObjRender_SetZWrite(obj, false);
	ObjRender_SetZTest(obj, false);
	let xsrc = GetTextureWidth(cloudimg);
	let ysrc = GetTextureHeight(cloudimg);
	ObjSprite3D_SetSourceRect(obj, 0, 0, xsrc, ysrc);
	ObjSprite3D_SetDestRect(obj, -xsrc/2, 0, xsrc/2, ysrc);
	ObjRender_SetColor(obj, rand(224, 248)*lcmod, rand(224, 248)*lcmod, 255*lcmod);
	
	let mscl = 700/y*0.25;
	// let mscl = 0.3;
	ObjRender_SetScaleXYZ(obj, mscl*(1-2*round(rand(0, 1))), mscl, mscl);
	ObjRender_SetAngleZ(obj, 180);
	
	ObjSprite3D_SetBillboard(obj, true);
	
	let alpha = rand(192, 255);
	
	ascent(i in 0..del){
		ObjRender_SetAlpha(obj, alpha/del*i);
		MoveCloud;
		yield;
	}
	
	ascent(i in 0..dur){
		MoveCloud;
		yield;
	}
	
	descent(i in 0..del){
		ObjRender_SetAlpha(obj, alpha/del*i);
		MoveCloud;
		yield;
	}
	
	Obj_Delete(obj);
	
	sub MoveCloud{
		ObjRender_SetPosition(obj, x, y, z);
		x+=mx;
		y+=my;
		z+=mz;
	}
}




